--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/df/cnc1900_df.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/df/cnc1900_df.c	2015-04-15 17:25:10.999290000 +0800
@@ -0,0 +1,2643 @@
+#include <linux/device.h>
+#include <linux/types.h>
+#include <linux/fs.h>
+#include <linux/delay.h>
+#include <linux/miscdevice.h>
+#include <linux/proc_fs.h>
+#include <linux/interrupt.h>
+#include <linux/module.h>
+#include <linux/fb.h>
+#include <asm/io.h>
+#include <asm/uaccess.h>
+#include <mach/pinmux.h>
+#include <mach/cnc1900_vpp_reg_def.h>
+#include <mach/cnc1900_df.h>
+#include <mach/cnc1900_power_clk.h>
+#include <mach/cnc1900_scalor_coef.h>
+#include <mach/mem_define.h>
+
+#include "tve0_1900.h"
+#include "tve1_1900.h"
+#include "df_output_format.h"
+//#include "../video/video_handshake_def.h"
+//#include "../video/cnc1900_video.h"
+//#include "../video/video_reg_def_cnc1900.h"
+
+#define DF_IRQ_DEBUG (0)
+
+#ifdef CONFIG_CELESTIAL_DF_DEBUG
+#define DEBUG_PRINTF  printk
+#else
+#define DEBUG_PRINTF(fmt,args...)
+#endif
+
+#if DF_IRQ_DEBUG
+#define DF_IRQ_PRINTF printk
+#else
+#define DF_IRQ_PRINTF(fmt,args...)
+#endif
+
+#define DF_MAJOR			200
+
+#define DF_MINOR_GFX0		0
+#define DF_MINOR_GFX1		1
+#define DF_MINOR_VID0		2
+#define DF_MINOR_VID1		3
+#define DF_MINOR_OUT0		4
+#define DF_MINOR_OUT1		5
+#define DF_MINOR_TVE0		6
+#define DF_MINOR_TVE1		7
+#define DF_MINOR_VIDAUX	8
+
+#ifdef CONFIG_HD2SD_ENABLE
+int __Is_hd2sd = 1;
+#else
+int __Is_hd2sd = 0;
+#endif
+static int __Is_ColorBar = 0;
+static int __Is_first = 1;
+int __VGA_Support = 0;
+int __Is_TV = 1;
+
+static int _Is_interlace = 0;
+static unsigned int _Frame_rate = 3000;
+
+#if 1
+extern int outputmode;
+#else
+int outputmode = -1;
+#endif
+
+int hdcp_enabled = -1;
+EXPORT_SYMBOL(hdcp_enabled);
+static int __init root_hdcp_setup(char *str)
+{
+	hdcp_enabled = simple_strtoul(str, NULL, 0);
+	return 1;
+}
+
+__setup("hdcp=", root_hdcp_setup);
+
+//extern _HOST_FW_IF_t *host2videofw_if;
+//extern unsigned int __video_write(unsigned int val, unsigned int addr);
+//extern unsigned int __video_read(unsigned int addr);
+//extern unsigned int clock_read_fixme(unsigned int idcs_reg_addr);
+extern int __change_tg_request(unsigned int TgId);
+extern int __change_tg_release(unsigned int TgId);
+extern int __video_tve_2_tg(int layer);
+extern void __video_set_hd2sd(unsigned int tg1_width, unsigned int tg1_height, unsigned int tg2_width, unsigned int tg2_height);
+extern void __video_send_hd2sd_cmd(int cmd);
+extern void __video_set_layer_position(int layer, unsigned int w, unsigned int h, unsigned int is_interlace, unsigned int frame_rate);
+
+volatile unsigned char  *disp_base = NULL;
+volatile unsigned char  *tve0_base = NULL;
+volatile unsigned char  *tve1_base = NULL;
+
+static dfdev df_dev[9];
+static int tve_2_df[] = {
+	DISP_YUV_PAL,
+	DISP_YUV_NTSC,
+	DISP_YUV_576P,
+	DISP_YUV_480P,
+	DISP_YUV_720P_50FPS,
+	DISP_YUV_720P_60FPS,
+	DISP_YUV_1080I_25FPS,
+	DISP_YUV_1080I_30FPS,
+
+	DISP_YUV_PAL,
+	DISP_YUV_NTSC,
+	DISP_YUV_PAL,
+	DISP_YUV_PAL,
+	DISP_YUV_1080P_24FPS,
+	DISP_YUV_1080P_25FPS,
+	DISP_YUV_1080P_30FPS,
+	DISP_YUV_1080P_50FPS,
+	DISP_YUV_1080P_60FPS,
+
+	DISP_YUV_PAL,
+	DISP_YUV_NTSC,
+	DISP_YUV_NTSC,
+	DISP_YUV_NTSC,
+	DISP_YUV_576P,
+	DISP_YUV_480P,
+	DISP_YUV_480P,
+	DISP_YUV_480P,
+	DISP_YUV_720P_60FPS,
+	DISP_YUV_1080I_30FPS,
+	DISP_YUV_1080P_24FPS,
+	DISP_YUV_1080P_60FPS,
+
+	DISP_YUV_720P_60FPS_3D,
+	DISP_YUV_720P_60FPS_3D,
+	DISP_YUV_720P_50FPS_3D,
+	DISP_YUV_1080P_24FPS_3D,
+	DISP_YUV_1080P_24FPS_3D,
+
+	DISP_YUV_1080I_25FPS,
+	DISP_YUV_1080I_30FPS,
+	DISP_YUV_1080I_30FPS,
+
+	DISP_YUV_720P_50FPS,
+	DISP_YUV_720P_60FPS,
+	DISP_YUV_720P_60FPS,
+	DISP_YUV_1080P_24FPS,
+	DISP_YUV_1080P_24FPS,
+
+	DISP_RGB_VGA_60FPS,
+	DISP_RGB_CVT_800x600_60,
+	DISP_RGB_XGA_60FPS,
+	DISP_RGB_CVT_1280x720_60,
+	DISP_RGB_DMT_800x600_60,
+	DISP_RGB_DMT_1440x900_60,
+	DISP_RGB_DMT_1280x1024_60,
+	DISP_RGB_DMT_1360x768_60,
+	DISP_YUV_1080P_30FPS,
+	DISP_YUV_1080P_60FPS,
+	DISP_YUV_1080I_30FPS,
+	DISP_VGA_1366x768,
+	DISP_RGB_VGA_59P94FPS,
+	DISP_1600x1200_60FPS,
+};
+
+static int tve_2_clock[] = {
+	_YUV_PAL,
+	_YUV_480I_60Hz,
+	_YUV_576P_50Hz,
+	_YUV_480P_60Hz,
+	_YUV_720P_50Hz,
+	_YUV_720P_60Hz,
+	_YUV_1080I_50Hz,
+	_YUV_1080I_60Hz,
+
+	_YUV_PAL,
+	_YUV_NTSC,
+	_YUV_PAL,
+	_YUV_PAL,
+	_YUV_1080P_24Hz,
+	_YUV_1080P_25Hz,
+	_YUV_1080P_30Hz,
+	_YUV_1080P_50Hz,
+	_YUV_1080P_60Hz,
+
+	_YUV_PAL,
+	_YUV_NTSC,
+	_YUV_NTSC,
+	_YUV_480I_60Hz,
+	_YUV_576P_50Hz,
+	_YUV_480P_59p94Hz,
+	_YUV_480P_59p94Hz,
+	_YUV_480P_60Hz,
+	_YUV_720P_59p94Hz,
+	_YUV_1080I_59p94Hz,
+	_YUV_1080P_23p98Hz,
+	_YUV_1080P_59p94Hz,
+
+	_YUV_1080P_59p94Hz,
+	_YUV_1080P_60Hz,
+	_YUV_1080P_60Hz,
+	_YUV_1080P_59p94Hz,
+	_YUV_1080P_60Hz,
+
+	_YUV_1080I_50Hz,
+	_YUV_1080I_59p94Hz,
+	_YUV_1080I_60Hz,
+
+	_YUV_720P_50Hz,
+	_YUV_720P_59p94Hz,
+	_YUV_720P_60Hz,
+	_YUV_1080P_23p98Hz,
+	_YUV_1080P_24Hz,
+
+	_RGB_DMT_640x480_60Hz,
+	_RGB_DMT_800x600_60Hz,
+	_RGB_DMT_1024x768_60Hz,
+	_YUV_720P_60Hz,
+	_RGB_DMT_800x600_60Hz,
+	_RGB_DMT_1440x900_60Hz,
+	_RGB_DMT_1280x1024_60Hz,
+	_RGB_DMT_1360x768_60Hz,
+	_YUV_1080P_30Hz,
+	_YUV_1080P_60Hz,
+	_YUV_1080I_60Hz,
+	_RGB_DMT_1360x768_60Hz,
+	_RGB_DMT_640x480_59P94Hz,
+	_RGB_DMT_1600x1200_60Hz,
+};
+
+static int tve_2_clock1[]={
+	_YUV_PAL_disp1,
+	_YUV_NTSC_disp1,
+	_YUV_576P_50Hz_disp1,
+	_YUV_480P_60Hz_disp1,
+	-1,
+	-1,
+	-1,
+	-1,
+	_YUV_SECAM_disp1,
+	_YUV_PAL_M_disp1,
+	_YUV_PAL_N_disp1,
+	_YUV_PAL_CN_disp1,
+};
+
+DEFINE_SPINLOCK(cnc_df_lock);
+
+#define REG_MAP_ADDR(x)	(((((x)>>16)&0xffff) == 0xb180)  ? (disp_base+((x)&0xffff)) :  \
+		(((((x)>>12)&0xfffff) == 0x80160) ? (tve1_base+((x)&0xfff)) :      \
+		 ((((x)>>12)&0xfffff) == 0x80168) ? (tve0_base+((x)&0xfff)):0))
+
+#define df_write8(a,v)	writeb(v,REG_MAP_ADDR(a))
+#define df_write16(a,v)	writew(v,REG_MAP_ADDR(a))
+#define df_write(a,v)	writel(v,REG_MAP_ADDR(a))
+#define df_read8(a)	readb(REG_MAP_ADDR(a))
+#define df_read16(a)	readw(REG_MAP_ADDR(a))
+#define df_read(a)	readl(REG_MAP_ADDR(a))
+
+df_reg_para dfreg;
+
+#define USE_VIDEO_LAYER2 0
+
+DF_OUTPUT_CONFIG_t df_output_config = {
+	.gfx_output = {0,0},
+#if	USE_VIDEO_LAYER2
+	.vid_output = {0,0,1},
+#else
+	.vid_output = {0,1,0},
+#endif
+	.output_mode = {DF_OUTPUT_YPBPR, DF_OUTPUT_YPBPR},
+};
+
+typedef enum
+{
+    DF_ZORDER_G1_G2_V1_V2 = 0X2301, //<front to Back: gfx0, gfx1, video0, video1
+    DF_ZORDER_V1_V2_G1_G2 = 0X123,  //<front to Back: video0, video1, gfx0, gfx1
+    DF_ZORDER_G2_G1_V2_V1 = 0X3210, //<front to Back: gfx1, gfx0, video1, video0
+    DF_ZORDER_V2_V1_G2_G1 = 0X1032, //<front to Back: video1, video0, gfx1, gfx0
+    DF_ZORDER_G1_V1_G2_V2 = 0X1302, //<front to Back: gfx0, video0, gfx1, video1
+    DF_ZORDER_V2_G2_V1_G1 = 0X2031  //<front to Back: video1, gfx1, video0, gfx0
+} CSTVOUT_DF_ZORDER;
+
+unsigned int DF_Read(unsigned int addr)
+{
+	return df_read(addr);
+}
+EXPORT_SYMBOL(DF_Read);
+
+void DF_Write(unsigned int addr, unsigned int data)
+{
+	df_write(addr, data);
+	return;
+}
+EXPORT_SYMBOL(DF_Write);
+
+unsigned char TVE_Read(unsigned int tveid, unsigned int addr)
+{
+	unsigned int data_rd;
+	unsigned int addr_full;
+	unsigned int addr32;
+	unsigned int data32;
+
+	if(tveid == 0)
+		addr_full = TVE0_REG_BASE + addr;
+	else if(tveid == 1)
+		addr_full = TVE1_REG_BASE+addr;
+	else
+		return (-1);
+
+	addr32 = addr_full & (~3);
+	data32 = df_read(addr32);
+
+	switch(addr_full&0x3){
+	case 0x0:
+		data_rd = data32 & 0xFF;
+		break;
+	case 0x1:
+		data_rd =(data32>>8)&0xFF;
+		break;
+	case 0x2:
+		data_rd =(data32>>16)&0xFF;
+		break;
+	case 0x3:
+		data_rd =(data32>>24)&0xFF;
+		break;
+	default:
+		data_rd=0;
+	}
+	return (((unsigned char)data_rd) & 0xFF);
+}
+
+void TVE_Write(unsigned int tveid, unsigned int addr, unsigned char data)
+{
+	unsigned char data_rd;
+	unsigned int addr_full;
+	unsigned int addr32;
+	unsigned int data32;
+
+	if(tveid == 0)
+		addr_full = TVE0_REG_BASE + addr;
+	else if(tveid == 1)
+		addr_full = TVE1_REG_BASE + addr;
+	else
+		return;
+
+	addr32 = addr_full & (~3);
+	data32 = df_read(addr32);
+
+	switch(addr_full & 0x3)
+	{
+	case 0x0:
+		data32 = (data32 & (~0xFF))|data;
+		break;
+	case 0x1:
+		data32 = (data32 & (~0xFF00))|(((unsigned int)data)<<8);
+		break;
+	case 0x2:
+		data32 = (data32 & (~0xFF0000))|(((unsigned int)data)<<16);
+		break;
+	case 0x3:
+		data32 = (data32 & (~0xFF000000))|(((unsigned int)data)<<24);
+		break;
+	}
+
+	df_write(addr32, data32);
+
+	udelay(1);
+	data_rd = TVE_Read(tveid, addr);
+	if(data_rd != data){
+		DEBUG_PRINTF("TVE%d: Reg Write ERROR: addr_base = %02x, wr_data =%08x,rd_data = %08x\n",
+				tveid,addr,data,data_rd);
+	}
+
+	return;
+}
+
+int InitTVE0Raw(TVOUT_MODE DispFormat , int EnableColorBar)
+{
+	int i = 0;
+	int VIDEO_TYPE  = TVOUT_MODE_576I;
+	int IsHD = 0;
+	int IsProgressive = 0;
+
+	//Map the Display Format Value to TVE0 Format Value
+	switch (DispFormat)
+	{
+		case TVOUT_MODE_SECAM:
+			VIDEO_TYPE = TYPE_SECAM;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_PAL_N:
+			VIDEO_TYPE = TYPE_PAL_N;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_PAL_M:
+			VIDEO_TYPE = TYPE_PAL_M;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_PAL_CN:
+			VIDEO_TYPE = TYPE_PAL_CN;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_576I:
+			VIDEO_TYPE = TYPE_PAL;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_480I:
+			VIDEO_TYPE = TYPE_NTSC;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_1080I30:
+		case TVOUT_MODE_1080I5994:
+			VIDEO_TYPE = TYPE_1080i30;
+			IsHD = 1;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_1080I25:
+			VIDEO_TYPE = TYPE_1080i;
+			IsHD = 1;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_720P60:
+		case TVOUT_MODE_720P5994:
+			VIDEO_TYPE = TYPE_720p60;
+			IsHD = 1;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_720P50:
+			VIDEO_TYPE = TYPE_720p50;
+			IsHD = 1;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_480P:
+		case TVOUT_MODE_480P5994:
+			VIDEO_TYPE = TYPE_480p;
+			IsHD = 0;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_576P:
+			VIDEO_TYPE = TYPE_480p;
+			IsHD = 0;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_1080P24:
+		case TVOUT_MODE_1080P25:
+		case TVOUT_MODE_1080P30:
+		case TVOUT_MODE_1080P50:
+		case TVOUT_MODE_1080P60:
+		case TVOUT_MODE_1080P2397:
+		case TVOUT_MODE_1080P5994:
+		case TVOUT_MODE_720P5994_3DFP:
+		case TVOUT_MODE_720P60_3DFP:
+		case TVOUT_MODE_720P50_3DFP:
+		case TVOUT_MODE_1080P2397_3DFP:
+		case TVOUT_MODE_1080P24_3DFP:
+		case TVOUT_MODE_1080I50_3DSS:
+		case TVOUT_MODE_1080I5994_3DSS:
+		case TVOUT_MODE_1080I60_3DSS:
+		case TVOUT_MODE_1080P2397_3DTB:
+		case TVOUT_MODE_1080P24_3DTB:
+		case TVOUT_MODE_720P50_3DTB:
+		case TVOUT_MODE_720P5994_3DTB:
+		case TVOUT_MODE_720P60_3DTB:
+		case TVOUT_MODE_1600X1200_60FPS:
+			return 0;
+		default:
+			VIDEO_TYPE = TYPE_PAL;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+	}
+
+	//Hold TVE0 Timing
+	TVE_Write(0,TVE0_REG[0][REG_ADDR],0x1);
+
+	//DEBUG_PRINTF("[TVE0: INFO]probe REV_ID ..%d\n",TVE0_REG[1][REG_ADDR]);
+
+	for (i=2; i<TVE0_REG_NUM; i++)
+	{
+		//DEBUG_PRINTF("TVE0: ADDR=%03x,WriteDATA=%03x\n",TVE0_REG[i][REG_ADDR],TVE0_REG[i][VIDEO_TYPE]);
+		TVE_Write(0,TVE0_REG[i][REG_ADDR],TVE0_REG[i][VIDEO_TYPE]);
+	}
+
+	if (EnableColorBar)
+	{
+		unsigned char  RegValue = 0;
+		RegValue = TVE_Read(0,0x2);
+		RegValue |= (1 << 5);
+		TVE_Write(0,0x2,RegValue);
+	}
+	TVE_Write(0,TVE0_REG[0][REG_ADDR],0x0);
+	return 0;
+}
+
+int InitTVE1Raw( TVOUT_MODE DispFormat , int EnableColorBar)
+{
+	int i = 0;
+	int VIDEO_TYPE  = TVOUT_MODE_576I;
+	int IsHD = 0;
+	int IsProgressive = 0;
+
+	//Map the Display Format Value to TVE1 Format Value
+	switch (DispFormat){
+		case TVOUT_MODE_SECAM:
+			VIDEO_TYPE = TYPE_SECAM;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_PAL_N:
+			VIDEO_TYPE = TYPE_PAL_N;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_PAL_M:
+			VIDEO_TYPE = TYPE_PAL_M;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_PAL_CN:
+			VIDEO_TYPE = TYPE_PAL_CN;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_576I:
+			VIDEO_TYPE = TYPE_PAL;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_480I:
+			VIDEO_TYPE = TYPE_NTSC;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_1080I30:
+		case TVOUT_MODE_1080I25:
+			VIDEO_TYPE = TYPE_1080i;
+			IsHD = 1;
+			IsProgressive = 0;
+			break;
+		case TVOUT_MODE_720P60:
+			VIDEO_TYPE = TYPE_720p60;
+			IsHD = 1;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_720P50:
+			VIDEO_TYPE = TYPE_720p50;
+			IsHD = 1;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_480P:
+			VIDEO_TYPE = TYPE_480p;
+			IsHD = 0;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_576P:
+			VIDEO_TYPE = TYPE_480p;
+			IsHD = 0;
+			IsProgressive = 1;
+			break;
+		case TVOUT_MODE_1080P24:
+		case TVOUT_MODE_1080P25:
+		case TVOUT_MODE_1080P30:
+		case TVOUT_MODE_1080P50:
+		case TVOUT_MODE_1080P60:
+		case TVOUT_MODE_1080P2397:
+		case TVOUT_MODE_1080P5994:
+		case TVOUT_MODE_1080P2397_3DFP:
+		case TVOUT_MODE_1080P24_3DFP:
+			return 0;
+		default:
+			VIDEO_TYPE = TYPE_PAL;
+			IsHD = 0;
+			IsProgressive = 0;
+			break;
+	}
+	//printascii("1111111111\n");
+	//Hold TVE1 Timing
+	TVE_Write(1,TVE1_REG[0][REG_ADDR],0x1);
+	//DEBUG_PRINTF("[TVE1: INFO]probe REV_ID ..%d\n",TVE1_REG[1][REG_ADDR]);
+	//printascii("222222222222\n");
+
+	for (i=2; i<TVE1_REG_NUM; i++)
+	{
+		//DEBUG_PRINTF("TVE1: ADDR=%03x,WriteDATA=%03x\n",TVE1_REG[i][REG_ADDR],TVE1_REG[i][VIDEO_TYPE]);
+		TVE_Write(1,TVE1_REG[i][REG_ADDR],TVE1_REG[i][VIDEO_TYPE]);
+	}
+
+	if (EnableColorBar)
+	{
+		unsigned char RegValue = 0;
+		RegValue = TVE_Read(1,0x2);
+		RegValue |= (1 << 5);
+		TVE_Write(1,0x2,RegValue);
+	}
+	TVE_Write(1,TVE1_REG[0][REG_ADDR],0x0);
+
+	return 0;
+}
+
+static int dfreg_ctrl[16] =
+{
+	VPP_REG_GLB_CTRL_H_UPDATE_REG,VPP_REG_GLB_CTRL_M_UPDATE_REG,VPP_REG_GLB_CTRL_C_UPDATE_REG,VPP_REG_GLB_CTRL_SETTING,VPP_REG_GLB_CTRL_CLK_SETTING,
+		VPP_REG_GLB_CTRL_INT_STA_COP,VPP_REG_GLB_CTRL_INT_MSK_COP,VPP_REG_GLB_CTRL_INT_STA_HOST,VPP_REG_GLB_CTRL_INT_MSK_HOST,VPP_REG_GLB_CTRL_SCALE_COEF3,
+		VPP_REG_GLB_CTRL_SCALE_COEF4,VPP_REG_GLB_CTRL_SCALE_COEF6,VPP_REG_GLB_CTRL_CPU_WQ,VPP_REG_GLB_CTRL_COP_RQ,VPP_REG_GLB_CTRL_HAND_STATUS,VPP_REG_GLB_CTRL_TG_SETTING,
+};
+
+static int dfreg_gfx[2][14] =
+{
+	{VPP_REG_GFX_UI1_CTRL,VPP_REG_GFX_UI1_ALPHA_CTRL,VPP_REG_GFX_UI1_SIZE,VPP_REG_GFX_UI1_KEY_RED,VPP_REG_GFX_UI1_KEY_BLUE,VPP_REG_GFX_UI1_KEY_GREEN,
+		VPP_REG_GFX_UI1_BUF_START,VPP_REG_GFX_UI1_LINE_PITCH,VPP_REG_GFX_UI1_X_POSITON,VPP_REG_GFX_UI1_Y_POSITON,VPP_REG_GFX_UI1_BUF_START_3D,
+		VPP_REG_GFX_UI1_A8,VPP_REG_GFX_UI1_PHASE,VPP_REG_GFX_UI1_COEFF_GID,
+	},
+	{VPP_REG_GFX_UI2_CTRL,VPP_REG_GFX_UI2_ALPHA_CTRL,VPP_REG_GFX_UI2_SIZE,VPP_REG_GFX_UI2_KEY_RED,VPP_REG_GFX_UI2_KEY_BLUE,VPP_REG_GFX_UI2_KEY_GREEN,
+		VPP_REG_GFX_UI2_BUF_START,VPP_REG_GFX_UI2_LINE_PITCH,VPP_REG_GFX_UI2_X_POSITON,VPP_REG_GFX_UI2_Y_POSITON,VPP_REG_GFX_UI2_BUF_START_3D,
+		VPP_REG_GFX_UI2_A8,VPP_REG_GFX_UI2_PHASE,VPP_REG_GFX_UI2_COEFF_GID,
+	},
+};
+
+static int dfreg_comp[9] =
+{
+	VPP_REG_COMP_B2_BACK_GROUND,VPP_REG_COMP_B2_Z_ORDER,VPP_REG_COMP_B2_DEFAULT_ALPHA,VPP_REG_COMP_COLOR_ADJUST,VPP_REG_COMP_SHARP_Y_CTRL,
+		VPP_REG_COMP_SHARP_C_CTRL,VPP_REG_COMP_B3_BACK_GROUND,VPP_REG_COMP_B3_Z_ORDER,VPP_REG_COMP_B3_DEFAULT_ALPHA
+};
+
+static int dfreg_outif[2][9] =
+{
+	{VPP_REG_TG1_CTRL,VPP_REG_TG1_X_SIZE,VPP_REG_TG1_Y_SIZE,VPP_REG_TG1_HSYNC,VPP_REG_TG1_VSYNC,
+		VPP_REG_TG1_VGA_LEVEL,VPP_REG_TG1_V_START_LINE,VPP_REG_TG1_STA_DISP_SIZE,VPP_REG_TG1_STA_LINE
+	},
+	{VPP_REG_TG2_CTRL,VPP_REG_TG2_X_SIZE,VPP_REG_TG2_Y_SIZE,VPP_REG_TG2_HSYNC,VPP_REG_TG2_VSYNC,
+		VPP_REG_TG2_VGA_LEVEL,VPP_REG_TG2_V_START_LINE,VPP_REG_TG2_STA_DISP_SIZE,VPP_REG_TG2_STA_LINE
+	},
+};
+
+static int process_num = 0;
+typedef struct CSM1900_df_DEV_t {
+	int instance_num;
+} csm1900_df_dev;
+
+void __df_update_start(void)
+{
+	df_write(dfreg_ctrl[0], 1);
+	df_write(dfreg_ctrl[2], 1);
+}
+EXPORT_SYMBOL(__df_update_start);
+
+void __df_update_end(void)
+{
+	df_write(dfreg_ctrl[0], 0);
+	df_write(dfreg_ctrl[2], 0);
+}
+
+void __df_update_outif_start(void)
+{
+	df_write(dfreg_ctrl[1], 1);
+}
+EXPORT_SYMBOL(__df_update_outif_start);
+
+void __df_update_outif_end(void)
+{
+	df_write(dfreg_ctrl[1], 0);
+}
+EXPORT_SYMBOL(__df_update_outif_end);
+
+void __update_vid_handshake_start(void)
+{
+	int wait_times = 10;
+
+	do{
+		df_write(VPP_REG_GLB_CTRL_CPU_WQ,1);
+		wait_times--;
+		mdelay(10);
+		if (wait_times <= 0){
+			printk("%s : %s in line %d\n",__FILE__,__FUNCTION__,__LINE__);
+			return;
+		}
+	}while((df_read(VPP_REG_GLB_CTRL_HAND_STATUS)&0x03)!=0x01);
+}
+
+void __update_vid_handshake_finish(void)
+{
+	df_write(VPP_REG_GLB_CTRL_CPU_WQ,0);
+}
+
+void DFSetOutIFVideoFmt(int OutIFId, DF_VIDEO_FORMAT Format, int En)
+{
+	//For Safety Format Switching It's better Disable the output clk First
+	df_outif_reg *OutIFReg= NULL;
+
+	OutIFId = OutIFId & 0x1;
+	OutIFReg = &dfreg.OutIF[OutIFId];
+
+	OutIFReg->reg_tg_ctrl.val = df_read(dfreg_outif[OutIFId][0]);
+	OutIFReg->reg_tg_x_size.val = df_read(dfreg_outif[OutIFId][1]);
+	OutIFReg->reg_tg_y_size.val = df_read(dfreg_outif[OutIFId][2]);
+	OutIFReg->reg_tg_hsync.val = df_read(dfreg_outif[OutIFId][3]);
+	OutIFReg->reg_tg_vsync.val = df_read(dfreg_outif[OutIFId][4]);
+
+    OutIFReg->reg_tg_ctrl.bits.tg_en=En;
+    OutIFReg->reg_tg_ctrl.bits.tg_is_hd=outputFormatInfo[Format].mIsHD&0x01;
+    OutIFReg->reg_tg_ctrl.bits.tg_is_interlaced=0x01&outputFormatInfo[Format].mVidType&0x01;
+    OutIFReg->reg_tg_ctrl.bits.tg_is_pal=outputFormatInfo[Format].mPALFmt&0x01;
+    OutIFReg->reg_tg_ctrl.bits.tg_dither_mode=0;
+    OutIFReg->reg_tg_ctrl.bits.tg_hsync_pol=outputFormatInfo[Format].mHSyncPol&0x01;
+    OutIFReg->reg_tg_ctrl.bits.tg_vsync_pol=outputFormatInfo[Format].mVSyncPol&0x01;
+    OutIFReg->reg_tg_ctrl.bits.tg_dither_ena=1;
+    OutIFReg->reg_tg_ctrl.bits.tg_3d_act_space=outputFormatInfo[Format].m3dVactSpace&0xff;
+    OutIFReg->reg_tg_ctrl.bits.tg_3d_en=outputFormatInfo[Format].m3dEn&0x01;
+
+    OutIFReg->reg_tg_hsync.bits.tg_hsync_front_porch=outputFormatInfo[Format].mHSyncFP&0x3ff;
+    OutIFReg->reg_tg_hsync.bits.tg_hsync_width=outputFormatInfo[Format].mHSyncWidth&0x3ff;
+    OutIFReg->reg_tg_hsync.bits.tg_hsync_back_porch=outputFormatInfo[Format].mHSyncBP&0x3ff;
+
+    OutIFReg->reg_tg_vsync.bits.tg_vsync_front_porch=outputFormatInfo[Format].mVSyncFP&0xff;
+    OutIFReg->reg_tg_vsync.bits.tg_vsync_width=outputFormatInfo[Format].mVSyncWidth&0xff;
+    OutIFReg->reg_tg_vsync.bits.tg_vsync_back_porch=outputFormatInfo[Format].mVSyncBP&0xff;
+
+
+    OutIFReg->reg_tg_x_size.bits.tg_htotal=outputFormatInfo[Format].mHRes&0x1fff;
+    OutIFReg->reg_tg_x_size.bits.tg_hactive_width=outputFormatInfo[Format].mHActive&0xfff;
+    OutIFReg->reg_tg_y_size.bits.tg_vtotal=outputFormatInfo[Format].mVRes&0x1fff;
+    OutIFReg->reg_tg_y_size.bits.tg_vactive_height= outputFormatInfo[Format].mVActline&0xfff;
+
+    if(outputFormatInfo[Format].mIsYUVorRGB){
+	    OutIFReg->reg_tg_vga_level.bits.tg_vga_black_level=0;
+	    OutIFReg->reg_tg_vga_level.bits.tg_vga_white_level=1023;
+    }
+    else{
+	    OutIFReg->reg_tg_vga_level.bits.tg_vga_black_level=252;
+	    OutIFReg->reg_tg_vga_level.bits.tg_vga_white_level=800;
+    }
+
+    OutIFReg->reg_tg_sta_line.bits.tg_v_start_line_num=6;
+
+    df_write(dfreg_outif[OutIFId][1], dfreg.OutIF[OutIFId].reg_tg_x_size.val);
+    df_write(dfreg_outif[OutIFId][2], dfreg.OutIF[OutIFId].reg_tg_y_size.val);
+    df_write(dfreg_outif[OutIFId][3], dfreg.OutIF[OutIFId].reg_tg_hsync.val);
+    df_write(dfreg_outif[OutIFId][4], dfreg.OutIF[OutIFId].reg_tg_vsync.val);
+    df_write(dfreg_outif[OutIFId][5], dfreg.OutIF[OutIFId].reg_tg_vga_level.val);
+    df_write(dfreg_outif[OutIFId][6], dfreg.OutIF[OutIFId].reg_tg_sta_line.val);
+    df_write(dfreg_outif[OutIFId][0], dfreg.OutIF[OutIFId].reg_tg_ctrl.val);
+
+	return;
+}
+
+void DFSetZOrder(int OutIFId, int Gfx1ZOrder, int Gfx2ZOrder, int Video1ZOrder, int Video2ZOrder)
+{
+	df_compositor_reg *Reg= NULL;
+
+	Reg = &dfreg.Comp;
+	Reg->reg_comp_b2_z_order.val = df_read(dfreg_comp[1]);
+
+	Reg->reg_comp_b2_z_order.bits.blending2_gfx1_z_order   = Gfx1ZOrder;
+	Reg->reg_comp_b2_z_order.bits.blending2_gfx1_z_order   = Gfx2ZOrder;
+	Reg->reg_comp_b2_z_order.bits.blending2_video1_z_order = Video1ZOrder;
+	Reg->reg_comp_b2_z_order.bits.blending2_video2_z_order = Video2ZOrder;
+
+	df_write(dfreg_comp[1], Reg->reg_comp_b2_z_order.val);
+	return;
+}
+
+void DFSetBackGroud(int OutIFId, unsigned char BGY, unsigned char BGU, unsigned char BGV)
+{
+	df_compositor_reg *Reg= NULL;
+
+	Reg = &dfreg.Comp;
+	Reg->reg_comp_b2_back_ground.val = df_read(dfreg_comp[0]);
+
+	Reg->reg_comp_b2_back_ground.bits.blending2_bg_y = BGY;
+	Reg->reg_comp_b2_back_ground.bits.blending2_bg_u = BGU;
+	Reg->reg_comp_b2_back_ground.bits.blending2_bg_v = BGV;
+
+	df_write(dfreg_comp[0], Reg->reg_comp_b2_back_ground.val);
+	return;
+}
+
+void DFGfxSetEndian(int GfxId, unsigned int GfxEndian)
+{
+    df_gfx_reg *Reg= NULL;
+
+    GfxId   = GfxId & 0x1;
+	Reg = &dfreg.Gfx[GfxId];
+
+    Reg->reg_gfx_ui_ctrl.val = df_read(dfreg_gfx[GfxId][0]);
+    Reg->reg_gfx_ui_ctrl.bits.gfx_ui_endian = (GfxEndian & 0x3);
+
+    df_write(dfreg_gfx[GfxId][0], Reg->reg_gfx_ui_ctrl.val);
+
+    return;
+}
+
+void DFGfxEna(int GfxId, int IsEna, int IsRGB2YUVEna)
+{
+	df_gfx_reg *Reg= NULL;
+
+	GfxId   = GfxId & 0x1;
+	Reg = &dfreg.Gfx[GfxId];
+
+	Reg->reg_gfx_ui_ctrl.val = df_read(dfreg_gfx[GfxId][0]);
+
+	if(DF_OUTPUT_VGA == df_output_config.output_mode[df_output_config.gfx_output[GfxId]]){
+		IsRGB2YUVEna = 0;
+	}
+	else{
+		IsRGB2YUVEna = 1;
+	}
+
+	if(IsEna)
+	{
+		Reg->reg_gfx_ui_ctrl.bits.gfx_ui_ena = (1 << df_output_config.gfx_output[GfxId]);
+		Reg->reg_gfx_ui_ctrl.bits.gfx_ui_yuv_conv_ena = IsRGB2YUVEna;
+	}
+	else
+	{
+		Reg->reg_gfx_ui_ctrl.bits.gfx_ui_ena = 0;
+	}
+
+	DEBUG_PRINTF("layer_output.gfx_output[%d] = %d\n",GfxId,df_output_config.gfx_output[GfxId]);
+	DEBUG_PRINTF("Reg->df_gfx_control_reg.bits.iGfxEna = %d\n",Reg->reg_gfx_ui_ctrl.bits.gfx_ui_ena);
+
+	df_write(dfreg_gfx[GfxId][0], Reg->reg_gfx_ui_ctrl.val);
+
+	return;
+}
+
+void DFGfxSetAlpha(int GfxId, unsigned char DefaultAlpha, unsigned char ARGB1555Alpha0, unsigned char ARGB1555Alpha1)
+{
+	df_gfx_reg *Reg= NULL;
+
+	GfxId   = GfxId & 0x1;
+	Reg = &dfreg.Gfx[GfxId];
+
+	Reg->reg_gfx_ui_alpha_ctrl.val = df_read(dfreg_gfx[GfxId][1]);
+
+	Reg->reg_gfx_ui_alpha_ctrl.bits.gfx_ui_default_alpha   = DefaultAlpha & 0x3ff;
+	Reg->reg_gfx_ui_alpha_ctrl.bits.gfx_ui_argb1555_a0 = ARGB1555Alpha0 & 0x3ff;
+	Reg->reg_gfx_ui_alpha_ctrl.bits.gfx_ui_argb1555_a1 = ARGB1555Alpha1 & 0x3ff;
+
+	df_write(dfreg_gfx[GfxId][1], Reg->reg_gfx_ui_alpha_ctrl.val);
+	return;
+}
+
+void DFGfxGetAlpha(int GfxId, unsigned char *DefaultAlpha, unsigned char *ARGB1555Alpha0, unsigned char *ARGB1555Alpha1)
+{
+	df_gfx_reg *Reg= NULL;
+
+	GfxId   = GfxId & 0x1;
+	Reg = &dfreg.Gfx[GfxId];
+
+
+	Reg->reg_gfx_ui_alpha_ctrl.val = df_read(dfreg_gfx[GfxId][2]);
+
+	*DefaultAlpha = Reg->reg_gfx_ui_alpha_ctrl.bits.gfx_ui_default_alpha;
+	*ARGB1555Alpha0 = Reg->reg_gfx_ui_alpha_ctrl.bits.gfx_ui_argb1555_a0;
+	*ARGB1555Alpha1 = Reg->reg_gfx_ui_alpha_ctrl.bits.gfx_ui_argb1555_a1;
+
+	return;
+}
+
+void DFGfxSetColorKey(int GfxId, unsigned char KeyRMin, unsigned char KeyRMax, unsigned char KeyGMin, unsigned char KeyGMax, unsigned char KeyBMin, unsigned char KeyBMax)
+{
+	df_gfx_reg *Reg= NULL;
+
+	GfxId   = GfxId & 0x1;
+	Reg = &dfreg.Gfx[GfxId];
+
+	Reg->reg_gfx_ui_key_red.val = df_read(dfreg_gfx[GfxId][3]);
+	Reg->reg_gfx_ui_key_blue.val = df_read(dfreg_gfx[GfxId][4]);
+	Reg->reg_gfx_ui_key_green.val = df_read(dfreg_gfx[GfxId][5]);
+
+	Reg->reg_gfx_ui_key_red.bits.gfx_ui_r_min   = KeyRMin;
+	Reg->reg_gfx_ui_key_red.bits.gfx_ui_r_max   = KeyRMax;
+	Reg->reg_gfx_ui_key_blue.bits.gfx_ui_b_min  = KeyBMin;
+	Reg->reg_gfx_ui_key_blue.bits.gfx_ui_b_max  = KeyBMax;
+	Reg->reg_gfx_ui_key_green.bits.gfx_ui_g_min = KeyGMin;
+	Reg->reg_gfx_ui_key_green.bits.gfx_ui_g_max = KeyGMax;
+
+	df_write(dfreg_gfx[GfxId][3], Reg->reg_gfx_ui_key_red.val);
+	df_write(dfreg_gfx[GfxId][4], Reg->reg_gfx_ui_key_blue.val);
+	df_write(dfreg_gfx[GfxId][5], Reg->reg_gfx_ui_key_green.val);
+
+	return;
+}
+
+void DFGfxColorKeyEna(int GfxId,int IsEna)
+{
+	df_gfx_reg*Reg = NULL;
+
+	GfxId = GfxId & 0x1;
+	Reg = &dfreg.Gfx[GfxId];
+	Reg->reg_gfx_ui_ctrl.val = df_read(dfreg_gfx[GfxId][0]);
+
+	Reg->reg_gfx_ui_ctrl.bits.gfx_ui_color_keying_en = IsEna;
+
+	df_write(dfreg_gfx[GfxId][0], Reg->reg_gfx_ui_ctrl.val);
+
+	return;
+}
+
+
+void DFGfxOpaqueOnOff(int GfxId,int OnOff)
+{
+	df_gfx_reg*Reg = NULL;
+
+	GfxId = GfxId & 0x1;
+	Reg = &dfreg.Gfx[GfxId];
+	Reg->reg_gfx_ui_ctrl.val = df_read(dfreg_gfx[GfxId][0]);
+
+	Reg->reg_gfx_ui_ctrl.bits.gfx_ui_opaque = OnOff;
+
+	df_write(dfreg_gfx[GfxId][0], Reg->reg_gfx_ui_ctrl.val);
+
+	return;
+}
+
+
+void DFGfxConfigDistrect(int GfxId,unsigned int startx,unsigned int starty,unsigned int endx,unsigned int endy)
+{
+	df_gfx_reg*Reg = NULL;
+
+	GfxId = GfxId & 0x1;
+	Reg = &dfreg.Gfx[GfxId];
+	Reg->reg_gfx_ui_x_position.val = df_read(dfreg_gfx[GfxId][8]);
+
+	Reg->reg_gfx_ui_x_position.bits.gfx_ui_dst_x_start =startx;
+	Reg->reg_gfx_ui_x_position.bits.gfx_ui_dst_x_end=endx;
+
+	df_write(dfreg_gfx[GfxId][8], Reg->reg_gfx_ui_x_position.val);
+
+	Reg->reg_gfx_ui_y_position.val = df_read(dfreg_gfx[GfxId][9]);
+
+	Reg->reg_gfx_ui_y_position.bits.gfx_ui_dst_y_start =starty;
+	Reg->reg_gfx_ui_y_position.bits.gfx_ui_dst_y_end=endy;
+
+	df_write(dfreg_gfx[GfxId][9], Reg->reg_gfx_ui_y_position.val);
+}
+
+
+unsigned int coefflaginited=0;
+void DFGfxScalorCoef(void)
+{
+	unsigned int *regaddr3 = NULL;
+	unsigned int *regaddr4 = NULL;
+	unsigned int *regaddr6 = NULL;
+
+	if(!coefflaginited)
+		{
+		if(NULL== request_mem_region( SCALOR_COEF_REGION, SCALOR_COEF_SIZE, "scalor coef data"))
+			printk("failed to request scalor coef data\n");
+
+	        regaddr3=ioremap_nocache(SCALOR_COEF_REGION, SCALOR_COEF_SIZE/3);
+		//printk(KERN_INFO"scalor coef data 3=0x%08x\n",(unsigned int)regaddr3);
+		regaddr4=ioremap_nocache(SCALOR_COEF_REGION+SCALOR_COEF_SIZE/3, SCALOR_COEF_SIZE/3);
+		//printk(KERN_INFO"scalor coef data 4=0x%08x\n",(unsigned int)regaddr4);
+		regaddr6=ioremap_nocache(SCALOR_COEF_REGION+SCALOR_COEF_SIZE*2/3, SCALOR_COEF_SIZE/3);
+		//printk(KERN_INFO"scalor coef data 6=0x%08x\n",(unsigned int)regaddr6);
+
+		memcpy((char*)regaddr3,cof3tap,sizeof(cof3tap));
+		memcpy((char*)regaddr4,cof4tap,sizeof(cof4tap));
+		memcpy((char*)regaddr6,cof6tap,sizeof(cof6tap));
+
+
+		df_write(dfreg_ctrl[9],SCALOR_COEF_REGION);
+		df_write(dfreg_ctrl[10],SCALOR_COEF_REGION+SCALOR_COEF_SIZE/3);
+		df_write(dfreg_ctrl[11],SCALOR_COEF_REGION+SCALOR_COEF_SIZE*2/3);
+		/*printk(KERN_INFO"cof3tap readout=%x\n",df_read(dfreg_ctrl[9]));
+		printk(KERN_INFO"cof4tap readout=%x\n",df_read(dfreg_ctrl[10]));
+		printk(KERN_INFO"cof6tap readout=%x\n",df_read(dfreg_ctrl[11]));*/
+		}
+	coefflaginited=1;
+}
+
+
+void __df_calc_video_position(TVOUT_MODE pre_mode,TVOUT_MODE cur_mode, df_output_pos *pos)
+{
+	switch(cur_mode){
+		case TVOUT_MODE_576I:
+		case TVOUT_MODE_576I_16TO9:
+		case TVOUT_MODE_576P:
+		case TVOUT_MODE_576P50_16TO9:
+		case TVOUT_MODE_PAL_N:
+		case TVOUT_MODE_PAL_CN:
+		case TVOUT_MODE_SECAM:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 576;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 720;
+			break;
+		case TVOUT_MODE_480I:
+		case TVOUT_MODE_480I60_16TO9:
+		case TVOUT_MODE_480I5994:
+		case TVOUT_MODE_480I5994_16TO9:
+		case TVOUT_MODE_480P:
+		case TVOUT_MODE_PAL_M:
+		case TVOUT_MODE_480P5994:
+		case TVOUT_MODE_480P5994_16TO9:
+		case TVOUT_MODE_480P60_16TO9:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 480;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 720;
+			break;
+		case TVOUT_MODE_720P50:
+		case TVOUT_MODE_720P60:
+		case TVOUT_MODE_720P5994:
+		case TVOUT_MODE_720P5994_3DFP:
+		case TVOUT_MODE_720P60_3DFP:
+        	case TVOUT_MODE_720P50_3DFP:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 720;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 1280;
+			break;
+		case TVOUT_MODE_1080I25:
+		case TVOUT_MODE_1080I30:
+		case TVOUT_MODE_1080P24:
+		case TVOUT_MODE_1080P25:
+		case TVOUT_MODE_1080P30:
+		case TVOUT_MODE_1080P50:
+		case TVOUT_MODE_1080P60:
+		case TVOUT_MODE_1080I5994:
+		case TVOUT_MODE_1080P2397:
+		case TVOUT_MODE_1080P5994:
+		case TVOUT_MODE_1080P2397_3DFP:
+		case TVOUT_MODE_1080P24_3DFP:
+		case TVOUT_RGB_1920X1080P30:
+		case TVOUT_RGB_1920X1080P60:
+		case TVOUT_RGB_1920X1080I30:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 1080;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 1920;
+			break;
+		case TVOUT_RGB_640X480_60FPS:
+		case TVOUT_RGB_640X480_5994FPS:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 480;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 640;
+			break;
+		case TVOUT_RGB_800X600_60FPS:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 600;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 800;
+			break;
+		case TVOUT_RGB_1024X768_60FPS:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 768;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 1024;
+			break;
+#if 0
+		case TVOUT_RGB_1280X1024_50FPS:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 1024;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 1280;
+			break;
+
+		case TVOUT_RGB_1600X1000_60FPS:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 1000;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 1600;
+			break;
+#endif
+		case TVOUT_RGB_1280X720_60FPS:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 720;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 1280;
+			break;
+#if 0
+		case TVOUT_RGB_848X480_60FPS:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 848;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 480;
+			break;
+#endif
+		case TVOUT_RGB_1280X1024_60FPS:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 1024;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 1280;
+			break;
+		case TVOUT_RGB_800X480_60FPS:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 800;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 480;
+			break;
+		case TVOUT_RGB_1440X900_60FPS:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 1440;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 900;
+			break;
+		case TVOUT_RGB_1360X768_60FPS:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 768;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 1360;
+			break;
+		case TVOUT_RGB_1366X768_60FPS:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 768;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 1366;
+			break;
+		case TVOUT_MODE_1600X1200_60FPS:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 1200;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 1600;
+			break;
+		default:
+			pos->src.top = pos->dst.top = 0;
+			pos->src.bottom = pos->dst.bottom = 576;
+			pos->src.left = pos->dst.left = 0;
+			pos->src.right = pos->dst.right = 720;
+			break;
+	}
+}
+
+int Get_Outif_Id(int gfx_id)
+{
+	return df_output_config.gfx_output[gfx_id];
+}
+
+int Get_Video_Id(int tve_id)
+{
+	if(tve_id == df_output_config.vid_output[0]) return 0;
+	else if(tve_id == df_output_config.vid_output[1]) return 1;
+	else if(tve_id == df_output_config.vid_output[2]) return 2;
+
+	return -1;
+}
+
+int Get_Gfx_Id(int tve_id)
+{
+	if(tve_id == df_output_config.gfx_output[0]) return 0;
+	else if(tve_id == df_output_config.gfx_output[1]) return 1;
+
+	return -1;
+}
+
+EXPORT_SYMBOL(Get_Outif_Id);
+
+//#define HAND_SHAKE_WITH_VIDEO_FIRMWARE DF_STATUS_SWITCH_REG //0x48 //0x23
+static int dummy_bri = 0;
+static void __SetBrightness(unsigned int bri)
+{
+    unsigned char brightness = bri & 0xff;
+    union{
+        struct{
+            unsigned int enh_bright:8;
+            unsigned int enh_contrast:6;
+            unsigned int reserved_1:2;
+            unsigned int enh_saturation:8;
+            unsigned int reserved_2:8;
+        }bits;
+        unsigned int val;
+    }adjust;
+
+    //fixed df bug that the brightness is 127, the display too dark
+    if(brightness == 127){
+        dummy_bri = 1;    
+        return;
+    }else{
+        dummy_bri = 0;    
+    }
+
+    if(brightness & 128)
+        brightness = brightness - 128; 
+    else
+        brightness = 255 - brightness; 
+
+    adjust.val = df_read(VPP_REG_COMP_COLOR_ADJUST);
+
+    adjust.bits.enh_bright = brightness;
+    df_write(VPP_REG_COMP_COLOR_ADJUST, adjust.val);
+}
+
+static unsigned int __GetBrightness(void)
+{
+    unsigned char brightness;
+    union{
+        struct{
+            unsigned int enh_bright:8;
+            unsigned int enh_contrast:6;
+            unsigned int reserved_1:2;
+            unsigned int enh_saturation:8;
+            unsigned int reserved_2:8;
+        }bits;
+        unsigned int val;
+    }adjust;
+
+    if(dummy_bri){
+        return 127;
+    }
+
+    adjust.val = df_read(VPP_REG_COMP_COLOR_ADJUST);
+    brightness = adjust.bits.enh_bright & 0xff;
+
+    if(brightness & 128)
+        brightness = 255 - brightness; 
+    else
+        brightness = 128 + brightness; 
+    return brightness;
+}
+static void __SetContrast(unsigned int con)
+{
+    union{
+        struct{
+            unsigned int enh_bright:8;
+            unsigned int enh_contrast:6;
+            unsigned int reserved_1:2;
+            unsigned int enh_saturation:8;
+            unsigned int reserved_2:8;
+        }bits;
+        unsigned int val;
+    }adjust;
+
+    adjust.val = df_read(VPP_REG_COMP_COLOR_ADJUST);
+
+    adjust.bits.enh_contrast = con & 0x3F;
+    df_write(VPP_REG_COMP_COLOR_ADJUST, adjust.val);
+}
+static unsigned int __GetContrast(void)
+{
+    union{
+        struct{
+            unsigned int enh_bright:8;
+            unsigned int enh_contrast:6;
+            unsigned int reserved_1:2;
+            unsigned int enh_saturation:8;
+            unsigned int reserved_2:8;
+        }bits;
+        unsigned int val;
+    }adjust;
+
+    adjust.val = DF_Read(VPP_REG_COMP_COLOR_ADJUST);
+    return adjust.bits.enh_contrast;
+}
+
+static void __SetSaturation(unsigned int sat)
+{
+    union{
+        struct{
+            unsigned int enh_bright:8;
+            unsigned int enh_contrast:6;
+            unsigned int reserved_1:2;
+            unsigned int enh_saturation:8;
+            unsigned int reserved_2:8;
+        }bits;
+        unsigned int val;
+    }adjust;
+
+    adjust.val = df_read(VPP_REG_COMP_COLOR_ADJUST);
+    adjust.bits.enh_saturation = sat & 0xFF;
+    df_write(VPP_REG_COMP_COLOR_ADJUST, adjust.val);
+}
+static unsigned int __GetSaturation(void)
+{
+    union{
+        struct{
+            unsigned int enh_bright:8;
+            unsigned int enh_contrast:6;
+            unsigned int reserved_1:2;
+            unsigned int enh_saturation:8;
+            unsigned int reserved_2:8;
+        }bits;
+        unsigned int val;
+    }adjust;
+
+    adjust.val = DF_Read(VPP_REG_COMP_COLOR_ADJUST);
+    return adjust.bits.enh_saturation;
+
+}
+static void __SetSharpness(unsigned int sharpness)
+{
+    union{
+        struct{
+            unsigned int enh_y_sharp_en:1;
+            unsigned int enh_y_median_en:1;
+            unsigned int enh_y_coring_soft:1;
+            unsigned int reserved_1:1;
+            unsigned int enh_y_peaking_shrink:3;
+            unsigned int reserved_2:1;
+            unsigned int enh_y_coring:6;
+            unsigned int reserved_3:2;
+            unsigned int enh_y_bpw:8;
+            unsigned int enh_y_hpw:8;
+        }bits;
+        unsigned int val;
+    }reg_comp_sharp_y;
+
+    union{
+        struct{
+            unsigned int enh_c_sharp_en:1;
+            unsigned int enh_c_median_en:1;
+            unsigned int enh_c_coring_soft:1;
+            unsigned int reserved_1:1;
+            unsigned int enh_c_peaking_shrink:3;
+            unsigned int reserved_2:1;
+            unsigned int enh_c_coring:6;
+            unsigned int reserved_3:2;
+            unsigned int enh_c_bpw:8;
+            unsigned int enh_c_hpw:8;
+        }bits;
+        unsigned int val;
+    }reg_comp_sharp_c;
+
+    reg_comp_sharp_y.val = DF_Read(VPP_REG_COMP_SHARP_Y_CTRL);
+    reg_comp_sharp_c.val = DF_Read(VPP_REG_COMP_SHARP_C_CTRL);
+
+    reg_comp_sharp_y.bits.enh_y_sharp_en = sharpness ? 1 : 0;
+    reg_comp_sharp_c.bits.enh_c_sharp_en = sharpness ? 1 : 0;
+
+    DF_Write(VPP_REG_COMP_SHARP_Y_CTRL, reg_comp_sharp_y.val);
+    DF_Write(VPP_REG_COMP_SHARP_C_CTRL, reg_comp_sharp_c.val);
+}
+static unsigned int __GetSharpness(void)
+{
+     union{
+        struct{
+            unsigned int enh_y_sharp_en:1;
+            unsigned int enh_y_median_en:1;
+            unsigned int enh_y_coring_soft:1;
+            unsigned int reserved_1:1;
+            unsigned int enh_y_peaking_shrink:3;
+            unsigned int reserved_2:1;
+            unsigned int enh_y_coring:6;
+            unsigned int reserved_3:2;
+            unsigned int enh_y_bpw:8;
+            unsigned int enh_y_hpw:8;
+        }bits;
+        unsigned int val;
+    }reg_comp_sharp_y;
+
+    union{
+        struct{
+            unsigned int enh_c_sharp_en:1;
+            unsigned int enh_c_median_en:1;
+            unsigned int enh_c_coring_soft:1;
+            unsigned int reserved_1:1;
+            unsigned int enh_c_peaking_shrink:3;
+            unsigned int reserved_2:1;
+            unsigned int enh_c_coring:6;
+            unsigned int reserved_3:2;
+            unsigned int enh_c_bpw:8;
+            unsigned int enh_c_hpw:8;
+        }bits;
+        unsigned int val;
+    }reg_comp_sharp_c;
+
+    reg_comp_sharp_y.val = DF_Read(VPP_REG_COMP_SHARP_Y_CTRL);
+    reg_comp_sharp_c.val = DF_Read(VPP_REG_COMP_SHARP_C_CTRL);
+
+    return reg_comp_sharp_y.bits.enh_y_sharp_en & reg_comp_sharp_c.bits.enh_c_sharp_en;
+}
+
+
+//G1_G2_V1_V2:0x1032
+//V1_V2_G1_G2:0x3210
+//G2_G1_V2_V1:0x123
+//V2_V1_G2_G1:0x2301
+//G1_V1_G2_V2:0x2031
+
+static void __Set_B2_ZOrder(unsigned int zorder)
+{
+    DF_Write(VPP_REG_COMP_B2_Z_ORDER, zorder);
+}
+
+static unsigned int __Get_B2_ZOrder(void)
+{
+    return DF_Read(VPP_REG_COMP_B3_Z_ORDER);
+}
+
+//static void __Set_B3_ZOrder(unsigned int zorder)
+//{
+//    union{
+//        struct{
+//            unsigned int blending3_video1_z_order:2;
+//            unsigned int reserved_1:2;
+//            unsigned int reserved_2:4;
+//            unsigned int blending3_gfx1_z_order:2;
+//            unsigned int reserved_3:4;
+//            unsigned int reserved_4:18;
+//        }bits;
+//        unsigned int val;
+//    }b3_z_order;
+//
+//    b3_z_order.val = 0;
+//    b3_z_order.bits.blending3_gfx1_z_order = 1;
+//    b3_z_order.bits.blending3_video1_z_order = 2;
+//
+//    DF_Write(VPP_REG_COMP_B3_Z_ORDER, DF_Read(VPP_REG_COMP_B3_Z_ORDER) | b3_z_order.val);
+//}
+//static int __Get_B3_ZOrder(void)
+//{
+//   union{
+//        struct{
+//            unsigned int blending3_video1_z_order:2;
+//            unsigned int reserved_1:2;
+//            unsigned int reserved_2:4;
+//            unsigned int blending3_gfx1_z_order:2;
+//            unsigned int reserved_3:4;
+//            unsigned int reserved_4:18;
+//        }bits;
+//        unsigned int val;
+//    }b3_z_order;
+//
+//    b3_z_order.val = DF_Read(VPP_REG_COMP_B3_Z_ORDER);
+//    return b3_z_order.val;
+//}
+
+static int __set_tv_mode(unsigned long arg, unsigned int minor_id)
+{
+	int tveid;
+	df_output_pos pos;
+
+	tveid = (minor_id == DF_MINOR_TVE1)? 1:0;
+
+	if(__Is_first){
+		pinmux_set_dac0mode(_dac0_tve0_ypbpr);
+		pinmux_set_dac1mode(_dac1_tve1_cvbs_svideo);
+#ifdef CONFIG_YPBPR_DAC_ENABLE
+		clock_dac0_enaclock(_clock_enable);
+#endif
+#ifdef CONFIG_HD2SD_ENABLE
+		clock_dac1_enaclock(_clock_enable);
+#endif
+	}
+
+    switch(arg){
+		case TVOUT_MODE_SECAM:
+		case TVOUT_MODE_PAL_N:
+		case TVOUT_MODE_PAL_M:
+		case TVOUT_MODE_PAL_CN:
+		case TVOUT_MODE_576I:
+		case TVOUT_MODE_576I_16TO9:
+		case TVOUT_MODE_480I:
+		case TVOUT_MODE_480I60_16TO9:
+		case TVOUT_MODE_480I5994:
+		case TVOUT_MODE_480I5994_16TO9:
+		case TVOUT_MODE_1080I25:
+		case TVOUT_MODE_1080I30:
+		case TVOUT_MODE_1080I5994:
+		case TVOUT_MODE_1080I50_3DSS:
+		case TVOUT_MODE_1080I5994_3DSS:
+		case TVOUT_MODE_1080I60_3DSS:
+            _Is_interlace = 1;
+            break;
+        default:
+            _Is_interlace = 0;
+    }
+
+    switch(arg){
+    	case TVOUT_MODE_SECAM:
+		case TVOUT_MODE_PAL_N:
+		case TVOUT_MODE_PAL_M:
+		case TVOUT_MODE_PAL_CN:
+		case TVOUT_MODE_480I:
+		case TVOUT_MODE_480I60_16TO9:
+		case TVOUT_MODE_480I5994:
+		case TVOUT_MODE_480I5994_16TO9:
+		case TVOUT_MODE_1080I30:
+		case TVOUT_MODE_1080P30:
+		case TVOUT_RGB_1920X1080I30:
+		case TVOUT_RGB_1920X1080P30:
+		case TVOUT_MODE_1080I5994:
+		case TVOUT_MODE_1080I5994_3DSS:
+		case TVOUT_MODE_1080I60_3DSS:
+            _Frame_rate = 3000;
+            break;
+		case TVOUT_MODE_1080P24:
+		case TVOUT_MODE_1080P2397:
+		case TVOUT_MODE_1080P2397_3DFP:
+		case TVOUT_MODE_1080P24_3DFP:
+		case TVOUT_MODE_1080P24_3DTB:
+		case TVOUT_MODE_1080P2397_3DTB:
+            _Frame_rate = 2400;
+            break;
+		case TVOUT_MODE_576I:
+		case TVOUT_MODE_576I_16TO9:
+		case TVOUT_MODE_1080I25:
+		case TVOUT_MODE_1080P25:
+		case TVOUT_MODE_1080I50_3DSS:
+            _Frame_rate = 2500;
+            break;
+		case TVOUT_MODE_576P:
+		case TVOUT_MODE_576P50_16TO9:
+		case TVOUT_MODE_720P50:
+		case TVOUT_MODE_1080P50:
+		case TVOUT_MODE_720P50_3DFP:
+		case TVOUT_MODE_720P50_3DTB:
+            _Frame_rate = 5000;
+            break;
+		case TVOUT_MODE_480P:
+		case TVOUT_MODE_480P60_16TO9:
+		case TVOUT_MODE_480P5994:
+		case TVOUT_MODE_480P5994_16TO9:
+		case TVOUT_MODE_720P60:
+		case TVOUT_MODE_1080P60:
+    		case TVOUT_RGB_640X480_60FPS:
+    		case TVOUT_RGB_640X480_5994FPS:
+		case TVOUT_RGB_800X600_60FPS:
+		case TVOUT_RGB_800X480_60FPS:
+		case TVOUT_RGB_1024X768_60FPS:
+		case TVOUT_RGB_1280X720_60FPS:
+		case TVOUT_RGB_1440X900_60FPS:
+		case TVOUT_RGB_1280X1024_60FPS:
+		case TVOUT_RGB_1360X768_60FPS:
+		case TVOUT_RGB_1366X768_60FPS:
+		case TVOUT_RGB_1920X1080P60:
+		case TVOUT_MODE_720P5994:
+		case TVOUT_MODE_1080P5994:
+		case TVOUT_MODE_720P5994_3DFP:
+		case TVOUT_MODE_720P60_3DFP:
+		case TVOUT_MODE_720P5994_3DTB:
+		case TVOUT_MODE_720P60_3DTB:
+		case TVOUT_MODE_1600X1200_60FPS:
+            _Frame_rate = 6000;
+            break;
+        default:
+            _Frame_rate = 3000;
+    }
+
+	switch (arg){
+		case TVOUT_MODE_SECAM:
+		case TVOUT_MODE_PAL_N:
+		case TVOUT_MODE_PAL_M:
+		case TVOUT_MODE_PAL_CN:
+		case TVOUT_MODE_576I:
+		case TVOUT_MODE_576P:
+		case TVOUT_MODE_480I:
+		case TVOUT_MODE_480P:
+		case TVOUT_MODE_720P50:
+		case TVOUT_MODE_720P60:
+		case TVOUT_MODE_1080I25:
+		case TVOUT_MODE_1080I30:
+		case TVOUT_MODE_1080P24:
+		case TVOUT_MODE_1080P25:
+		case TVOUT_MODE_1080P30:
+		case TVOUT_MODE_1080P50:
+		case TVOUT_MODE_1080P60:
+		case TVOUT_MODE_576I_16TO9:
+		case TVOUT_MODE_576P50_16TO9:
+		case TVOUT_MODE_480I60_16TO9:
+		case TVOUT_MODE_480I5994:
+		case TVOUT_MODE_480I5994_16TO9:
+		case TVOUT_MODE_480P5994:
+		case TVOUT_MODE_480P5994_16TO9:
+		case TVOUT_MODE_480P60_16TO9:
+		case TVOUT_MODE_720P5994:
+		case TVOUT_MODE_1080I5994:
+		case TVOUT_MODE_1080P2397:
+		case TVOUT_MODE_1080P5994:
+		case TVOUT_MODE_720P5994_3DFP:
+		case TVOUT_MODE_720P60_3DFP:
+		case TVOUT_MODE_720P50_3DFP:
+		case TVOUT_MODE_1080P2397_3DFP:
+		case TVOUT_MODE_1080P24_3DFP:
+		case TVOUT_MODE_1080I50_3DSS:
+		case TVOUT_MODE_1080I5994_3DSS:
+		case TVOUT_MODE_1080I60_3DSS:
+		case TVOUT_MODE_720P50_3DTB:
+		case TVOUT_MODE_720P5994_3DTB:
+		case TVOUT_MODE_720P60_3DTB:
+		case TVOUT_MODE_1080P2397_3DTB:
+		case TVOUT_MODE_1080P24_3DTB:
+		case TVOUT_MODE_1600X1200_60FPS:
+			if(DF_OUTPUT_CVBS_SVIDEO == df_output_config.output_mode[tveid]){
+				pinmux_set_dac0mode(_dac0_tve0_cvbs_svideo);
+			}
+			else{
+				pinmux_set_dac0mode(_dac0_tve0_ypbpr);
+			}
+			__Is_TV = 1;
+			break;
+		case TVOUT_RGB_640X480_60FPS:
+		case TVOUT_RGB_640X480_5994FPS:
+		case TVOUT_RGB_800X600_60FPS:
+		case TVOUT_RGB_800X480_60FPS:
+		case TVOUT_RGB_1024X768_60FPS:
+		case TVOUT_RGB_1280X720_60FPS:
+		case TVOUT_RGB_1440X900_60FPS:
+		case TVOUT_RGB_1280X1024_60FPS:
+		case TVOUT_RGB_1360X768_60FPS:
+		case TVOUT_RGB_1920X1080P30:
+		case TVOUT_RGB_1920X1080P60:
+		case TVOUT_RGB_1920X1080I30:
+		case TVOUT_RGB_1366X768_60FPS:
+			pinmux_set_dac0mode(_dac0_rgb0);
+			__Is_TV = 0;
+			break;
+
+		default:
+			break;
+	}
+	DEBUG_PRINTF("tevid = %d, mode = %d\n",tveid,(int)arg);
+
+    __change_tg_request(tveid);
+
+	__df_calc_video_position(df_dev[minor_id].tve_format,arg,&pos);
+	df_dev[minor_id].tve_format = arg;
+
+	if(0 == tveid){
+	        printk("df_dev[minor_id].tve_format=%d\n",df_dev[minor_id].tve_format);
+	        printk("tve_2_clock[df_dev[minor_id].tve_format]=%d\n",tve_2_clock[df_dev[minor_id].tve_format]);
+
+		clock_disp0_setclock(tve_2_clock[df_dev[minor_id].tve_format]);
+	}
+	else if(1 == tveid){
+		clock_disp1_setclock(tve_2_clock1[df_dev[minor_id].tve_format]);
+	}
+
+	mdelay(10);
+
+	if(__Is_TV){
+		if(tveid == 0){
+#ifdef CONFIG_YPBPR_DAC_ENABLE
+			InitTVE0Raw(df_dev[minor_id].tve_format, __Is_ColorBar);
+#else
+			;
+#endif
+		}
+		else if(tveid == 1){
+#ifdef CONFIG_HD2SD_ENABLE
+			InitTVE1Raw(df_dev[minor_id].tve_format, __Is_ColorBar);
+#else
+			;
+#endif
+		}
+		mdelay(10);
+	}
+
+	__df_update_outif_start();
+	        printk("tve_2_df[df_dev[minor_id].tve_format]=%d\n",tve_2_df[df_dev[minor_id].tve_format]);
+	DFSetOutIFVideoFmt(tveid,tve_2_df[df_dev[minor_id].tve_format],1);
+	__df_update_outif_end();
+	mdelay(10);
+#if 1
+	__update_vid_handshake_start();
+	__video_set_layer_position(__video_tve_2_tg(tveid), pos.dst.right, pos.dst.bottom, _Is_interlace, _Frame_rate);
+	__update_vid_handshake_finish();
+#endif
+    __change_tg_release(tveid);
+
+	if((tveid == 0) && (__Is_hd2sd)){
+		switch (df_dev[minor_id].tve_format){
+			case TVOUT_MODE_SECAM:
+				df_dev[minor_id+1].tve_format = TVOUT_MODE_SECAM;
+				break;
+			case TVOUT_MODE_PAL_CN:
+				df_dev[minor_id+1].tve_format = TVOUT_MODE_PAL_CN;
+				break;
+			case TVOUT_MODE_PAL_N:
+				df_dev[minor_id+1].tve_format = TVOUT_MODE_PAL_N;
+				break;
+			case TVOUT_MODE_PAL_M:
+				df_dev[minor_id+1].tve_format = TVOUT_MODE_PAL_M;
+				break;
+			case TVOUT_MODE_576I:
+			case TVOUT_MODE_576I_16TO9:
+			case TVOUT_MODE_1080I25:
+			case TVOUT_MODE_576P:
+			case TVOUT_MODE_576P50_16TO9:
+			case TVOUT_MODE_720P50:
+			case TVOUT_MODE_1080P25:
+			case TVOUT_MODE_1080P50:
+			case TVOUT_MODE_1080I50_3DSS:
+			case TVOUT_MODE_720P50_3DTB:
+				df_dev[minor_id+1].tve_format = TVOUT_MODE_576I;
+				break;
+			case TVOUT_MODE_480I:
+			case TVOUT_MODE_480I60_16TO9:
+			case TVOUT_MODE_480I5994:
+			case TVOUT_MODE_480I5994_16TO9:
+			case TVOUT_MODE_480P:
+			case TVOUT_MODE_720P60:
+			case TVOUT_MODE_1080I30:
+			case TVOUT_MODE_1080P24:
+			case TVOUT_MODE_1080P30:
+			case TVOUT_MODE_1080P60:
+			case TVOUT_MODE_480P5994:
+			case TVOUT_MODE_480P5994_16TO9:
+			case TVOUT_MODE_480P60_16TO9:
+			case TVOUT_MODE_720P5994:
+			case TVOUT_MODE_1080I5994:
+			case TVOUT_MODE_1080P2397:
+			case TVOUT_MODE_1080P5994:
+			case TVOUT_MODE_720P5994_3DFP:
+			case TVOUT_MODE_720P60_3DFP:
+			case TVOUT_MODE_720P50_3DFP:
+			case TVOUT_MODE_1080P2397_3DFP:
+			case TVOUT_MODE_1080P24_3DFP:
+			case TVOUT_RGB_640X480_60FPS:
+			case TVOUT_RGB_640X480_5994FPS:
+			case TVOUT_RGB_800X600_60FPS:
+			case TVOUT_RGB_1024X768_60FPS:
+			case TVOUT_RGB_1280X720_60FPS:
+			case TVOUT_RGB_800X480_60FPS:
+			case TVOUT_RGB_1440X900_60FPS:
+			case TVOUT_RGB_1280X1024_60FPS:
+			case TVOUT_RGB_1360X768_60FPS:
+			case TVOUT_RGB_1920X1080P30:
+			case TVOUT_RGB_1920X1080P60:
+			case TVOUT_RGB_1920X1080I30:
+			case TVOUT_RGB_1366X768_60FPS:
+			case TVOUT_MODE_1080I5994_3DSS:
+			case TVOUT_MODE_1080I60_3DSS:
+			case TVOUT_MODE_720P5994_3DTB:
+			case TVOUT_MODE_720P60_3DTB:
+			case TVOUT_MODE_1080P2397_3DTB:
+			case TVOUT_MODE_1080P24_3DTB:
+			case TVOUT_MODE_1600X1200_60FPS:
+				df_dev[minor_id+1].tve_format = TVOUT_MODE_480I;
+				break;
+
+			default:
+				df_dev[minor_id+1].tve_format = TVOUT_MODE_576I;
+				DEBUG_PRINTF("kernel: TVOUT_MODE_576I\n");
+				break;
+		}
+
+		switch(df_dev[minor_id+1].tve_format){
+			case TVOUT_MODE_576I:
+			case TVOUT_MODE_PAL_N:
+			case TVOUT_MODE_PAL_CN:
+			case TVOUT_MODE_SECAM:
+				pos.dst.right = 720;
+				pos.dst.bottom = 576;
+				break;
+			case TVOUT_MODE_480I:
+			case TVOUT_MODE_PAL_M:
+				pos.dst.right = 720;
+				pos.dst.bottom = 480;
+				break;
+			default:
+				pos.dst.right = 720;
+				pos.dst.bottom = 480;
+				break;
+		}
+
+		clock_disp1_setclock(tve_2_clock1[df_dev[minor_id+1].tve_format]);
+		mdelay(10);
+		InitTVE1Raw(df_dev[minor_id+1].tve_format, __Is_ColorBar);
+		__df_update_outif_start();
+		DFSetOutIFVideoFmt(1,tve_2_df[df_dev[minor_id+1].tve_format],1);
+		__df_update_outif_end();
+		mdelay(10);
+#if 1
+		__update_vid_handshake_start();
+        __video_set_hd2sd(pos.src.right - pos.src.left, pos.src.bottom - pos.src.top, pos.dst.right - pos.dst.left, pos.dst.bottom - pos.dst.top);
+		//__video_set_hd2sd(pos);
+		__update_vid_handshake_finish();
+		__video_send_hd2sd_cmd(1); //play
+#endif
+	}
+
+	__Is_first = 0;
+
+    return 0;
+}
+
+static int cnc_tve_ioctl(unsigned int cmd, unsigned long arg, unsigned int minor_id)
+{
+	int tveid;
+
+	tveid = (minor_id == DF_MINOR_TVE1)? 1:0;
+
+	switch (cmd) {
+		case CSTVE_IOC_GET_BIND_INF:
+			if (copy_to_user((void *) arg, (void *) &df_output_config, sizeof(DF_OUTPUT_CONFIG_t))) {
+				return -EFAULT;
+			}
+			break;
+		case CSDF_IOC_GET_INIT_OUTPUTMODE:
+			__put_user(outputmode, (int __user *) arg);
+			break;
+
+		case CSTVE_IOC_ENABLE:
+			if(tveid == 0){
+#ifdef CONFIG_YPBPR_DAC_ENABLE
+				clock_dac0_enaclock(_clock_enable);
+#endif
+				clock_hdmi_reset(_do_set);
+			}
+			else if(tveid == 1){
+#ifdef CONFIG_HD2SD_ENABLE
+				clock_dac1_enaclock(_clock_enable);
+#else
+				;
+#endif
+			}
+			else
+				printk("parameters errorn\n!");
+			break;
+
+		case CSTVE_IOC_DISABLE:
+			if(tveid == 0){
+				clock_dac0_enaclock(_clock_disable);
+				clock_hdmi_reset(_do_reset);
+			}
+			else if(tveid == 1)
+				clock_dac1_enaclock(_clock_disable);
+			else
+				printk("parameters errorn\n!");
+			break;
+
+		case CSTVE_IOC_SET_OUTPUT:
+			df_output_config.output_mode[tveid] = arg;
+			DEBUG_PRINTF("layer_output.output_mode[%d] = %d\n",tveid,(int)arg);
+			break;
+		case CSTVE_IOC_SET_HDMI_IN_BYPASS:
+			if((unsigned int)arg == 0)
+				clock_hdmi_bypass(_sel_ttl);
+			else if((unsigned int)arg == 1)
+				clock_hdmi_bypass(_sel_vib);
+			else
+				printk("parameters errorn\n!");
+			break;
+
+		case CSTVE_IOC_SET_HDMI_IN_ENBALE:
+			if((unsigned int)arg == 0)
+				pinmux_enable_ttlout();
+			else if((unsigned int)arg == 1)
+				pinmux_enable_vib();
+			else
+				printk("parameters errorn\n!");
+			break;
+		case CSTVE_IOC_SET_MODE:
+		printk("arg=%d\n",arg);
+            __set_tv_mode((unsigned int)arg, minor_id);
+		    break;
+		case CSTVE_IOC_GET_MODE:
+			__put_user(df_dev[minor_id].tve_format, (int __user *) arg);
+			break;
+		case CSDF_IOC_Z_ORDER:
+			//df_write(dfreg_comp[1], arg);
+			__df_update_start();
+ 			__Set_B2_ZOrder((unsigned int)arg);
+			__df_update_end();
+			break;
+        case CSDF_IOC_GET_Z_ORDER:
+            __put_user(__Get_B2_ZOrder(), (int __user*)arg);
+        break;
+        case CSDF_IOC_SET_BRIGHTNESS:
+		__df_update_start();
+		__SetBrightness((unsigned int)arg);
+		__df_update_end();
+	 break;
+        case CSDF_IOC_GET_BRIGHTNESS:
+            __put_user(__GetBrightness(), (int __user*)arg);
+            break;
+        case CSDF_IOC_SET_CONTRAST:
+		__df_update_start();
+		__SetContrast((unsigned int)arg);
+		__df_update_end();
+		break;
+        case CSDF_IOC_GET_CONTRAST:
+            __put_user(__GetContrast(), (int __user*)arg);
+            break;
+        case CSDF_IOC_SET_SATURATION:
+		__df_update_start();
+            __SetSaturation((unsigned int)arg);
+		__df_update_end();
+            break;
+        case CSDF_IOC_GET_SATURATION:
+            __put_user(__GetSaturation(), (int __user*)arg);
+            break;
+        case CSDF_IOC_SET_SHARPNESS:
+		__df_update_start();
+            __SetSharpness((unsigned int)arg);
+		__df_update_end();
+            break;
+        case CSDF_IOC_GET_SHARPNESS:
+            __put_user(__GetSharpness(), (int __user*)arg);
+            break;
+        case CSDF_IOC_DISP_HD2SD_ENABLE:
+#ifdef CONFIG_HD2SD_ENABLE
+            if(arg == 1)
+                __Is_hd2sd = 1;
+            else
+                __Is_hd2sd = 0;
+#endif
+            break;
+		default:
+			break;
+	}
+	return 0;
+}
+
+static int cnc_df_gfx_ioctl(unsigned int cmd, unsigned long arg, unsigned int minor_id)
+{
+	printk("This node(Gfx layer) is not used!\n");
+	return 0;
+}
+
+static int cnc_df_vid_ioctl(unsigned int cmd, unsigned long arg, unsigned int minor_id)
+{
+	int vid_id;
+
+	if(DF_MINOR_VID0 == minor_id)
+		vid_id = 0;
+	else if(DF_MINOR_VID1 == minor_id)
+		vid_id = 1;
+	else if(DF_MINOR_VIDAUX == minor_id)
+		vid_id = 2;
+	else
+		return 0;
+
+	DEBUG_PRINTF("cnc_df_vid_ioctl : df video layer id = %d\n",vid_id);
+
+	switch (cmd) {
+		case CSDF_IOC_GET_VPP_REG_ADDR:
+			DEBUG_PRINTF("CSDF_IOC_GET_VPP_REG_ADDR\n");
+			__put_user(VPP_REG_BASE, (unsigned int __user *) arg);
+			break;
+
+		case CSDF_IOC_GET_VPP_REG_SIZE:
+			DEBUG_PRINTF("CSDF_IOC_GET_VPP_REG_SIZE\n");
+			__put_user(VPP_REG_SIZE, (unsigned int __user *) arg);
+			break;
+
+		case CSDF_IOC_DISP_VID_ALPHA:
+			DEBUG_PRINTF("CSDF_IOC_DISP_VID_ALPHA\n");
+		break;
+
+		case CSDF_IOC_DISP_POS:
+			{
+				DEBUG_PRINTF("CSDF_IOC_DISP_POS\n");
+				break;
+			}
+
+		default:
+			DEBUG_PRINTF("unknown cmd 0x%x\n",cmd);
+			break;
+	}
+
+	return 0;
+}
+
+static int cnc_df_outif_ioctl(unsigned int cmd, unsigned long arg, unsigned int minor_id)
+{
+	printk("This node(outif) is not used!\n");
+	return 0;
+}
+
+static long cnc_df_ioctl(struct file *file,unsigned int cmd, unsigned long arg)
+{
+	unsigned int minor_id = iminor(file->f_mapping->host);
+	DEBUG_PRINTF("cnc_df_ioctl\n");
+	if (minor_id == DF_MINOR_TVE0 || minor_id == DF_MINOR_TVE1){
+		cnc_tve_ioctl(cmd, arg, minor_id);
+	}
+
+	else if (minor_id == DF_MINOR_GFX0 || minor_id == DF_MINOR_GFX1){
+		cnc_df_gfx_ioctl(cmd, arg, minor_id);
+	}
+
+	else if (minor_id == DF_MINOR_VID0 || minor_id == DF_MINOR_VID1){
+		cnc_df_vid_ioctl(cmd, arg, minor_id);
+	}
+
+	else if (minor_id == DF_MINOR_VIDAUX){
+		cnc_df_vid_ioctl(cmd, arg, minor_id);
+	}
+
+	else if (minor_id == DF_MINOR_OUT0 || minor_id == DF_MINOR_OUT1){
+		cnc_df_outif_ioctl(cmd, arg, minor_id);
+	}
+
+	return 0;
+}
+
+int __df_mem_initialize(void)
+{
+	if (NULL == request_mem_region(VPP_REG_BASE, VPP_REG_SIZE, "CNC1900 VPP space")) {
+		goto INIT_ERR0;
+	}
+
+	if (NULL == disp_base){
+		if(!(disp_base = (unsigned char *)ioremap(VPP_REG_BASE, VPP_REG_SIZE))) {
+			goto INIT_ERR1;
+		}
+	}
+
+	if (NULL == request_mem_region(TVE0_REG_BASE, TVE0_REG_SIZE, "CNC1900 TVE0 space")) {
+		goto INIT_ERR2;
+	}
+
+	if (NULL == tve0_base){
+		if(!(tve0_base = (unsigned char *)ioremap(TVE0_REG_BASE, TVE0_REG_SIZE))) {
+			goto INIT_ERR3;
+		}
+	}
+
+	if (NULL == request_mem_region(TVE1_REG_BASE, TVE1_REG_SIZE, "CNC1900 TVE1 space")) {
+		goto INIT_ERR4;
+	}
+
+	if (NULL == tve1_base){
+		if(!(tve1_base = (unsigned char *)ioremap(TVE1_REG_BASE, TVE1_REG_SIZE))) {
+			goto INIT_ERR5;
+		}
+	}
+
+	printk("disp_base 0x%x, tve0_base 0x%x, tve1_base 0x%x\n",(unsigned int)disp_base,(unsigned int)tve0_base,(unsigned int)tve1_base);
+	return 0;
+
+INIT_ERR5:
+	printk(KERN_INFO "__df_mem_initialize INIT_ERR5 ...\n");
+	release_mem_region(TVE1_REG_BASE, TVE1_REG_SIZE);
+INIT_ERR4:
+	printk(KERN_INFO "__df_mem_initialize INIT_ERR4 ...\n");
+	iounmap((void *)tve0_base);
+INIT_ERR3:
+	printk(KERN_INFO "__df_mem_initialize INIT_ERR3 ...\n");
+	release_mem_region(TVE0_REG_BASE, TVE0_REG_SIZE);
+INIT_ERR2:
+	printk(KERN_INFO "__df_mem_initialize INIT_ERR2 ...\n");
+	iounmap((void *)disp_base);
+INIT_ERR1:
+	printk(KERN_INFO "__df_mem_initialize INIT_ERR1 ...\n");
+	release_mem_region(VPP_REG_BASE, VPP_REG_SIZE);
+INIT_ERR0:
+	printk(KERN_INFO "__df_mem_initialize INIT_ERR0 ...\n");
+	return -1;
+}
+
+void __df_mem_destroy(void)
+{
+	iounmap((void *)tve1_base);
+	release_mem_region(TVE1_REG_BASE, TVE1_REG_SIZE);
+	iounmap((void *)tve0_base);
+	release_mem_region(TVE0_REG_BASE, TVE0_REG_SIZE);
+	iounmap((void *)disp_base);
+	release_mem_region(VPP_REG_BASE, VPP_REG_SIZE);
+}
+
+static int df_proc_write(struct file *file, const char *buffer, unsigned long count, void *data)
+{
+	const char *cmd_line = buffer;
+
+	if (strncmp("tver1", cmd_line, 5) == 0) {
+		int addr;
+		addr = simple_strtol(&buffer[6], NULL, 16);
+		printk(" tve1[0x%08x] = 0x%08x \n", addr&0xff, TVE_Read(1, addr&0xff));
+	}
+	else if (strncmp("tvew1", cmd_line, 5) == 0) {
+		int addr, val;
+		addr = simple_strtol(&buffer[6], NULL, 16);
+		val = simple_strtol(&buffer[9], NULL, 16);
+		TVE_Write(1, addr&0xff, val&0xff);
+	}
+	else if (strncmp("tver0", cmd_line, 5) == 0) {
+		int addr;
+		addr = simple_strtol(&buffer[6], NULL, 16);
+		printk(" tve0[0x%08x] = 0x%08x \n", addr&0xff, TVE_Read(0, addr&0xff));
+	}
+	else if (strncmp("tvew0", cmd_line, 5) == 0) {
+		int addr, val;
+		addr = simple_strtol(&buffer[6], NULL, 16);
+		val = simple_strtol(&buffer[9], NULL, 16);
+		TVE_Write(0, addr&0xff, val&0xff);
+	}
+	else if (strncmp("rl", cmd_line, 2) == 0) {
+		int addr;
+		addr = simple_strtol(&buffer[3], NULL, 16);
+		printk(" addr[0x%08x] = 0x%08x \n", addr, df_read(addr));
+	}
+	else if (strncmp("wl", cmd_line, 2) == 0) {
+		int addr, val;
+		addr = simple_strtol(&buffer[3], NULL, 16);
+		val = simple_strtol(&buffer[12], NULL, 16);
+//		__df_update_start();
+		df_write(addr, val);
+//		__df_update_end();
+	}
+	else if (strncmp("enable_colorbar", cmd_line, 15) == 0) {
+		__Is_ColorBar = 1;
+	}
+	else if (strncmp("disable_colorbar", cmd_line, 16) == 0) {
+		__Is_ColorBar = 0;
+	}
+	else if(strncmp("480i", cmd_line, 4) == 0){
+		df_rect DispRect;
+		DispRect.top = 0;
+		DispRect.left = 0;
+		DispRect.right = 720;
+		DispRect.bottom = 480;
+
+		pinmux_enable_ttlout();
+
+		pinmux_set_dac0mode(_dac0_tve0_ypbpr);
+		pinmux_set_dac1mode(_dac1_tve1_cvbs_svideo);
+
+		clock_dac0_enaclock(_clock_enable);
+		clock_dac1_enaclock(_clock_enable);
+		clock_disp0_setclock(_YUV_480P_60Hz);
+		clock_disp1_setclock(_YUV_NTSC_disp1);
+
+//		clock_hdmiset_clockmode(_YUV_NTSC, _1x_disp_clk);
+printk("111111111\n");
+		InitTVE0Raw(TVOUT_MODE_480P, 1);
+printk("22222222\n");
+		InitTVE1Raw(TVOUT_MODE_480I, 1);
+printk("3333333\n");
+		__df_update_outif_start();
+printk("%s:%s in line %d\n",__FILE__,__FUNCTION__,__LINE__);
+		DFSetOutIFVideoFmt(0, DISP_YUV_480P,1);
+printk("%s:%s in line %d\n",__FILE__,__FUNCTION__,__LINE__);
+		DFSetOutIFVideoFmt(1, DISP_YUV_NTSC,1);
+printk("%s:%s in line %d\n",__FILE__,__FUNCTION__,__LINE__);
+		__df_update_outif_end();
+printk("4444444\n");
+	}
+	else if(strncmp("aaa", cmd_line, 3) == 0){
+		df_rect DispRect;
+		DispRect.top = 0;
+		DispRect.left = 0;
+		DispRect.right = 720;
+		DispRect.bottom = 480;
+
+		pinmux_enable_ttlout();
+
+		pinmux_set_dac0mode(_dac0_tve1_cvbs_svideo);
+		pinmux_set_dac1mode(_dac1_tve1_cvbs_svideo);
+
+		clock_dac0_enaclock(_clock_enable);
+		clock_dac1_enaclock(_clock_enable);
+		clock_disp0_setclock(_YUV_480P_60Hz);
+		clock_disp1_setclock(_YUV_NTSC_disp1);
+
+//		clock_hdmiset_clockmode(_YUV_NTSC, _1x_disp_clk);
+printk("111111111\n");
+		InitTVE0Raw(TVOUT_MODE_480P, 1);
+printk("22222222\n");
+		InitTVE1Raw(TVOUT_MODE_480I, 1);
+printk("3333333\n");
+		__df_update_outif_start();
+printk("%s:%s in line %d\n",__FILE__,__FUNCTION__,__LINE__);
+		DFSetOutIFVideoFmt(0, DISP_YUV_480P,1);
+printk("%s:%s in line %d\n",__FILE__,__FUNCTION__,__LINE__);
+		DFSetOutIFVideoFmt(1, DISP_YUV_NTSC,1);
+printk("%s:%s in line %d\n",__FILE__,__FUNCTION__,__LINE__);
+		__df_update_outif_end();
+printk("4444444\n");
+	}
+#if 0
+	else if(strncmp("480p", cmd_line, 4) == 0){
+		df_rect DispRect;
+		DispRect.top = 0;
+		DispRect.left = 0;
+		DispRect.right = 720;
+		DispRect.bottom = 480;
+
+		clock_dispset_dac1mode(_clock_wake);
+		clock_dispset_clockmode0(_disp0, _YUV_480P);
+		clock_hdmiset_clockmode(_YUV_480P, _1x_disp_clk);
+
+		InitTVE0Raw(TVOUT_MODE_480P, 1);
+		__df_update_start();
+		DFSetOutIFVideoFmt(0, DISP_YUV_480P);
+		DFOutIFEna(0, 1);
+		__df_update_end();
+
+	}
+	else if(strncmp("576i", cmd_line, 4) == 0){
+		df_rect DispRect;
+		DispRect.top = 0;
+		DispRect.left = 0;
+		DispRect.right = 720;
+		DispRect.bottom = 576;
+
+		clock_dispset_dac0mode(_clock_wake);
+		clock_dispset_dac1mode(_clock_wake);
+		clock_dispset_clockmode0(_disp0, _YUV_PAL);
+		clock_dispset_clockmode0(_disp1, _YUV_PAL);
+		clock_hdmiset_clockmode(_YUV_PAL, _1x_disp_clk);
+
+		InitTVE0Raw(TVOUT_MODE_576I, 1);
+		InitTVE1Raw(TVOUT_MODE_576I, 1);
+		__df_update_start();
+		DFSetOutIFVideoFmt(0, DISP_YUV_PAL);
+		DFSetOutIFVideoFmt(1, DISP_YUV_PAL);
+		DFOutIFEna(0, 1);
+		DFOutIFEna(1, 1);
+		__df_update_end();
+
+	}
+	else if(strncmp("576p", cmd_line, 4) == 0){
+		df_rect DispRect;
+		DispRect.top = 0;
+		DispRect.left = 0;
+		DispRect.right = 720;
+		DispRect.bottom = 576;
+
+		clock_dispset_dac1mode(_clock_wake);
+		clock_dispset_clockmode0(_disp0, _YUV_576P);
+		clock_hdmiset_clockmode(_YUV_576P, _1x_disp_clk);
+
+		InitTVE0Raw(TVOUT_MODE_576P, 1);
+		__df_update_start();
+		DFSetOutIFVideoFmt(0, DISP_YUV_576P);
+		DFOutIFEna(0, 1);
+		__df_update_end();
+
+	}
+	else if(strncmp("720p", cmd_line, 4) == 0){
+		df_rect DispRect;
+		DispRect.top = 0;
+		DispRect.left = 0;
+		DispRect.right = 720;
+		DispRect.bottom = 576;
+
+		clock_dispset_dac1mode(_clock_wake);
+		clock_dispset_clockmode0(_disp0, _YUV_720P_60Hz);
+		InitTVE0Raw(TVOUT_MODE_720P60, 1);
+		clock_hdmiset_clockmode(_YUV_720P_60Hz, _1x_disp_clk);
+
+		__df_update_start();
+		DFSetOutIFVideoFmt(0, DISP_YUV_720P_60FPS);
+		DFOutIFEna(0, 1);
+		__df_update_end();
+
+	}
+	else if(strncmp("1080p", cmd_line, 5) == 0){
+		df_rect DispRect;
+		DispRect.top = 0;
+		DispRect.left = 0;
+		DispRect.right = 720;
+		DispRect.bottom = 576;
+
+		clock_dispset_dac1mode(_clock_wake);
+		clock_dispset_clockmode0(_disp0, _YUV_1080P_60Hz);
+		clock_hdmiset_clockmode(_YUV_1080P_60Hz, _1x_disp_clk);
+
+		//	InitTVE0Raw(TVOUT_MODE_1, 0);
+		//	InitTVE1Raw(TVOUT_MODE_576P, 0);
+		__df_update_start();
+		DFSetOutIFVideoFmt(0, DISP_YUV_1080P_60FPS);
+		DFOutIFEna(0, 1);
+		__df_update_end();
+
+	}
+#endif
+#if 0
+	else if(strncmp("vga", cmd_line, 3) == 0){
+		df_rect DispRect;
+		DispRect.top = 0;
+		DispRect.left = 0;
+		DispRect.right = 720;
+		DispRect.bottom = 576;
+
+		pinmux_set_dac1mode(_dac1_disp0_rgb);
+		clock_dispset_dac0mode(_clock_wake);
+		clock_dispset_dac1mode(_clock_wake);
+		clock_dispset_clockmode0(_disp0, _RGB_CVT_1366x768_60Hz);
+		//		clock_dispset_clockmode0(_disp1, _YUV_1080P_60Hz);
+		//	InitTVE0Raw(TVOUT_MODE_1, 0);
+		//	InitTVE1Raw(TVOUT_MODE_576P, 0);
+		__df_update_start();
+		DFSetOutIFVideoFmt(0, DISP_RGB_1366x768);
+		__df_update_end();
+
+	}
+#endif
+#if 0
+	else if((strncmp("df_clock",cmd_line,8) == 0)){
+		CLOCK_ENA ClockEna = _clock_enable;
+		ClockEna = simple_strtol(&buffer[9], NULL, 16);
+		printk(" ClockEna = %d \n", ClockEna);
+		clock_df_clockena(ClockEna);
+	}
+	else if((strncmp("clock_tms_clockena",cmd_line,18) == 0)){
+		CLOCK_ENA ClockEna = _clock_enable;
+		ClockEna = simple_strtol(&buffer[19], NULL, 16);
+		printk(" ClockEna = %d \n", ClockEna);
+		clock_tms_clockena(ClockEna);
+	}
+	else if((strncmp("clock_cec_clockena",cmd_line,18) == 0)){
+		CLOCK_ENA ClockEna = _clock_enable;
+		ClockEna = simple_strtol(&buffer[19], NULL, 16);
+		printk(" ClockEna = %d \n", ClockEna);
+		clock_cec_clockena(ClockEna);
+	}
+#endif
+	else if((strncmp("dumpreg",cmd_line,7) == 0)){
+		unsigned int count = 0;
+
+		for(count = 0; count < 0x300; count +=4){
+			switch(count){
+				case 0x0:
+					printk("\n VPP_REG_CTRL_BASE\n");
+					break;
+				case (0x20<<2):
+					printk("\n VPP_REG_GFX_DMA_BASE\n");
+					break;
+				case (0x50<<2):
+					printk("\n VPP_REG_GFX_UI1_BASE\n");
+					break;
+				case (0x40<<2):
+					printk("\n VPP_REG_GFX_UI2_BASE\n");
+					break;
+				case (0x60<<2):
+					printk("\n VPP_REG_HD2SD_RD_BASE\n");
+					break;
+				case (0x80<<2):
+					printk("\n VPP_REG_CAP_BASE\n");
+					break;
+				case (0xa0<<2):
+					printk("\n VPP_REG_COMP_BASE\n");
+					break;
+				case (0xb0<<2):
+					printk("\n VPP_REG_TG1_BASE\n");
+					break;
+				case (0xc0<<2):
+					printk("\n VPP_REG_TG2_BASE\n");
+					break;
+				case (0x100<<2):
+					printk("\n VPP_REG_MAIN_CH_BASE\n");
+					break;
+				case (0x140<<2):
+					printk("\n VPP_REG_SR_CH_BASE\n");
+					break;
+			}
+			printk(" addr[0x%08x] = 0x%08x \n", VPP_REG_BASE + count, df_read(VPP_REG_BASE+count));
+		}
+
+	}
+
+	return count;
+}
+
+static int cnc_df_open(struct inode *inode, struct file *file)
+{
+	unsigned int minor_id = iminor(inode);
+    csm1900_df_dev *df_dev_temp = NULL;
+
+    if(NULL == file->private_data){
+        printk("func:%s  line:%d \n",__FUNCTION__,__LINE__);
+        df_dev_temp = kmalloc(sizeof(csm1900_df_dev), GFP_KERNEL);
+        if(NULL == df_dev_temp){
+            printk("func:%s  line:%d \n",__FUNCTION__,__LINE__);
+            return -EBUSY;
+        }
+        df_dev_temp->instance_num = 1;
+        file->private_data = (void *)df_dev_temp;
+        if(process_num > 0){
+            process_num ++;
+            if(__Is_first&&(minor_id==DF_MINOR_TVE0))
+            df_dev[minor_id].tve_format = outputmode;
+            goto CSM_DF_OPEN_SUCCEED;
+        }
+        else{
+            process_num ++;
+        }
+    }
+    else{
+        df_dev_temp = file->private_data;
+        df_dev_temp->instance_num ++;
+        printk("func:%s  line:%d instance_num = %d\n",__FUNCTION__,__LINE__,df_dev_temp->instance_num);
+        goto CSM_DF_OPEN_SUCCEED;
+    }
+
+	spin_lock_init(&(df_dev[minor_id].spin_lock));
+	df_dev[minor_id].enable = 1;
+	df_dev[minor_id].tve_format = outputmode;
+
+	DEBUG_PRINTF("%s was opened\n",df_dev[minor_id].name);
+
+	//	clock_ddc_clockena(_clock_enable);
+	//	clock_cec_clockena(_clock_enable);
+	//	clock_tms_clockena(_clock_enable);
+CSM_DF_OPEN_SUCCEED:
+	return 0;
+}
+
+static int cnc_df_release(struct inode *inode, struct file *file)
+{
+	unsigned int minor_id = iminor(inode);
+    csm1900_df_dev *df_dev_temp = NULL;
+
+    df_dev_temp = file->private_data;
+    df_dev_temp->instance_num--;
+
+	if(df_dev_temp->instance_num > 0){
+		//printk("func:%s  line:%d instance_num = %d, process_num = %d\n",__FUNCTION__,__LINE__,df_dev_temp->instance_num, process_num);
+		return 0;
+	}
+	else{
+		//printk("func:%s  line:%d instance_num = %d, process_num = %d\n",__FUNCTION__,__LINE__,df_dev_temp->instance_num, process_num);
+		kfree(file->private_data);
+		process_num --;
+		if(process_num <= 0){
+			df_dev[minor_id].enable = 0;
+		}
+	}
+
+	DEBUG_PRINTF("%s was released\n",df_dev[minor_id].name);
+
+	return 0;
+}
+
+
+static struct class *cnc_df_class;
+static struct proc_dir_entry *cnc_df_proc_entry = NULL;
+static struct file_operations cnc_df_fops = {
+	.owner	= THIS_MODULE,
+	.open	=  cnc_df_open,
+	.release	= cnc_df_release,
+	.unlocked_ioctl		= cnc_df_ioctl,
+};
+
+CNC_FB_INTERRUPT cncdf_1800_vblank_int[2];
+
+irqreturn_t cnc_outif0_irq(int irq, void *dev_id)
+{
+	DF_IRQ_PRINTF("cnc_outif0_irq!\n");
+
+	if (DF_Read(VPP_REG_GLB_CTRL_INT_STA_HOST) & 0x8)
+	{
+		if(cncdf_1800_vblank_int[0].is_display == 1){
+			cncdf_1800_vblank_int[0].is_display = 0;
+			wake_up(&cncdf_1800_vblank_int[0].wait);
+		}
+
+		if(cncdf_1800_vblank_int[1].is_display == 1){
+			cncdf_1800_vblank_int[1].is_display = 0;
+			wake_up(&cncdf_1800_vblank_int[1].wait);
+		}
+	}
+
+	DF_Write(VPP_REG_GLB_CTRL_INT_STA_HOST, DF_Read(VPP_REG_GLB_CTRL_INT_STA_HOST) | 0x8);
+
+	return IRQ_HANDLED;
+}
+
+#if 0
+irqreturn_t cnc_outif1_irq(int irq, void *dev_id)
+{
+	DF_IRQ_PRINTF("cnc_outif1_irq!\n");
+
+	if(cncdf_1800_vblank_int[1].is_display == 1){
+		cncdf_1800_vblank_int[1].is_display = 0;
+		wake_up(&cncdf_1800_vblank_int[1].wait);
+	}
+
+	DF_Write(DISP_INT_STA_HOST, DF_Read(DISP_INT_STA_HOST) | 0x20);
+
+	return IRQ_HANDLED;
+}
+#endif
+
+static void cnc_df_setup_dev(unsigned int minor_id, char * dev_name)
+{
+	device_create(cnc_df_class, NULL, MKDEV(DF_MAJOR, minor_id), NULL, dev_name);
+	df_dev[minor_id].dev_minor = minor_id;
+	df_dev[minor_id].dev_type = minor_id;
+	df_dev[minor_id].enable = 0;
+	df_dev[minor_id].tve_format = TVOUT_MODE_576I;
+	df_dev[minor_id].name = dev_name;
+}
+
+void __cnc_init_vpp(void)
+{
+    df_compositor_reg comp;
+
+    memset((void*)&comp, 0, sizeof(comp));
+
+    /*b2 bg*/
+    comp.reg_comp_b2_back_ground.bits.blending2_bg_y= 0;//Blend2.BgY;
+    comp.reg_comp_b2_back_ground.bits.blending2_bg_u= 128<<2;//Blend2.BgU;
+    comp.reg_comp_b2_back_ground.bits.blending2_bg_v= 128<<2;//Blend2.BgV;
+    /*b3 bg*/
+    comp.reg_comp_b3_back_ground.bits.blending3_bg_y= 0;//Blend3.BgY;
+    comp.reg_comp_b3_back_ground.bits.blending3_bg_u= 128<<2;//Blend3.BgU;
+    comp.reg_comp_b3_back_ground.bits.blending3_bg_v= 128<<2;//Blend3.BgV;
+
+    /*b2 order*/
+    comp.reg_comp_b2_z_order.bits.blending2_gfx1_z_order= 0;//Blend2.G1Order;
+    comp.reg_comp_b2_z_order.bits.blending2_gfx2_z_order= 1;//Blend2.G2Order;
+    comp.reg_comp_b2_z_order.bits.blending2_video1_z_order= 2;//Blend2.V1Order;
+    comp.reg_comp_b2_z_order.bits.blending2_video2_z_order= 3;//Blend2.V2Order;
+    /*b3 order*/
+    comp.reg_comp_b3_z_order.bits.blending3_gfx1_z_order= 1;//Blend3.G1Order;
+    comp.reg_comp_b3_z_order.bits.blending3_video1_z_order= 2;//Blend3.V1Order;
+
+    /*b2 alpha*/
+    comp.reg_comp_b2_default_alpha.bits.blending2_default_alpha1=0x3ff;
+    comp.reg_comp_b2_default_alpha.bits.blending2_default_alpha2=0x3ff;
+    /*b3 alpha*/
+    comp.reg_comp_b3_default_alpha.bits.blending3_default_alpha1=0x3ff;//--TBD
+
+    /*adjust*/
+    comp.reg_comp_color_adjust.bits.enh_bright= 0x0;//Color.Bright;
+    comp.reg_comp_color_adjust.bits.enh_contrast= 0x20;//Color.Contrast;
+    comp.reg_comp_color_adjust.bits.enh_saturation= 0x40;//Color.Saturation;
+    /*sharpness*/
+    comp.reg_comp_sharp_c.bits.enh_c_sharp_en= 1;//Color.sharp_en;// --TBD
+    comp.reg_comp_sharp_c.bits.enh_c_median_en=0;
+    comp.reg_comp_sharp_c.bits.enh_c_coring_soft=1;
+    comp.reg_comp_sharp_c.bits.enh_c_peaking_shrink=0;
+    comp.reg_comp_sharp_c.bits.enh_c_coring=0;
+    comp.reg_comp_sharp_c.bits.enh_c_bpw=0;
+    comp.reg_comp_sharp_c.bits.enh_c_hpw=0;
+
+    comp.reg_comp_sharp_y.bits.enh_y_sharp_en=1;
+    comp.reg_comp_sharp_y.bits.enh_y_median_en=0;
+    comp.reg_comp_sharp_y.bits.enh_y_coring_soft=1;// soft/hardware
+    comp.reg_comp_sharp_y.bits.enh_y_peaking_shrink=0;
+    comp.reg_comp_sharp_y.bits.enh_y_coring=0;
+    comp.reg_comp_sharp_y.bits.enh_y_bpw=0;
+    comp.reg_comp_sharp_y.bits.enh_y_hpw=0;
+
+    /*b2 bg*/
+    DF_Write(VPP_REG_COMP_B2_BACK_GROUND, comp.reg_comp_b2_back_ground.val);
+    /*b2 alpha*/
+    DF_Write(VPP_REG_COMP_B2_DEFAULT_ALPHA, comp.reg_comp_b2_default_alpha.val);
+    /*b2 order*/
+    //DF_Write(VPP_REG_COMP_B2_Z_ORDER, comp.reg_comp_b2_z_order.val);
+    /*b3 bg*/
+    DF_Write(VPP_REG_COMP_B3_BACK_GROUND, comp.reg_comp_b3_back_ground.val);
+    /*b3 alpha*/
+    DF_Write(VPP_REG_COMP_B3_DEFAULT_ALPHA, comp.reg_comp_b3_default_alpha.val);
+    /*b3 order*/
+    DF_Write(VPP_REG_COMP_B3_Z_ORDER, comp.reg_comp_b3_z_order.val);
+    /*adjust*/
+    DF_Write(VPP_REG_COMP_COLOR_ADJUST, comp.reg_comp_color_adjust.val);
+    /*sharpness*/
+    DF_Write(VPP_REG_COMP_SHARP_C_CTRL, comp.reg_comp_sharp_c.val);
+    DF_Write(VPP_REG_COMP_SHARP_Y_CTRL, comp.reg_comp_sharp_y.val);
+}
+
+static int __init cnc_df_init(void)
+{
+	clock_df_enaclock(_clock_enable);
+	clock_video_enaclock(_clock_enable);
+	clock_coda_enaclock(_clock_enable);
+	clock_jpeg_enaclock(_clock_enable);
+//#ifndef CONFIG_CELESTIAL_OTT_EMMC //Jack, if disable the fowllowing two lines, video will do not work
+	clock_vpb_enaclock(_clock_enable);
+	clock_vpbinput_enaclock(_clock_enable);
+//#endif
+
+	if (register_chrdev(DF_MAJOR, "cnc1900_df", &cnc_df_fops)){
+		__df_mem_destroy();
+		return -ENODEV;
+	}
+
+	cnc_df_class = class_create(THIS_MODULE,"cnc1900_df");
+	if (IS_ERR(cnc_df_class)){
+		printk(KERN_ERR "DF: class create failed.\n");
+		cnc_df_class = NULL;
+		return -ENODEV;
+	}
+
+	cnc_df_setup_dev(DF_MINOR_GFX0,  "cnc_1900_df_gfx0");
+	cnc_df_setup_dev(DF_MINOR_GFX1,  "cnc_1900_df_gfx1" );
+	cnc_df_setup_dev(DF_MINOR_VID0,  "cnc_1900_df_video0");
+	cnc_df_setup_dev(DF_MINOR_VID1,  "cnc_1900_df_video1");
+	cnc_df_setup_dev(DF_MINOR_OUT0,  "cnc_1900_df_output0");
+	cnc_df_setup_dev(DF_MINOR_OUT1,  "cnc_1900_df_output1");
+	cnc_df_setup_dev(DF_MINOR_TVE0,  "cnc_1900_tvout0");
+	cnc_df_setup_dev(DF_MINOR_TVE1,  "cnc_1900_tvout1");
+	cnc_df_setup_dev(DF_MINOR_VIDAUX,  "cnc_1900_df_vidaux");
+
+	__df_mem_initialize();
+
+	cnc_df_proc_entry = create_proc_entry("df19_io", 0, NULL);
+	if (NULL != cnc_df_proc_entry) {
+		cnc_df_proc_entry->write_proc = &df_proc_write;
+	}
+
+    //must be put after __df_mem_initialize() Jack.Sun 2013.8.8
+    //initialization tg1 tg2 alpha zorder sharpness bright contrast saturation and colors of background[2-3]
+    __cnc_init_vpp();
+
+	DF_Write(VPP_REG_GLB_CTRL_INT_MSK_HOST, DF_Read(VPP_REG_GLB_CTRL_INT_MSK_HOST) | 0x28);
+
+	if (request_irq(DISP1_IRQ, cnc_outif0_irq, 0, "cnc_df0", NULL)) {
+		printk(KERN_ERR "csdrv_df: cannot register outif0 IRQ \n");
+		return -EIO;
+	}
+
+#if 0
+	if (request_irq(25, cnc_outif1_irq, 0, "cs_df1", NULL)) {
+		printk(KERN_ERR "csdrv_df: cannot register outif1 IRQ \n");
+		return -EIO;
+	}
+#endif
+
+	printk("CNC1900L Display System Version : 0.2\n");
+
+	printk(KERN_INFO "%s: CNC Display feeder driver was initialized, at address@[phyical addr = %08x, size = %x] \n",
+			"cnc1800l_df", VPP_REG_BASE, VPP_REG_SIZE);
+	printk(KERN_INFO "%s: CNC TVE0 driver was initialized, at address@[phyical addr = %08x, size = %x] \n",
+			"cnc1800l_df", TVE0_REG_BASE, TVE0_REG_SIZE);
+	printk(KERN_INFO "%s: CNC TVE1 driver was initialized, at address@[phyical addr = %08x, size = %x] \n",
+			"cnc1800l_df", TVE1_REG_BASE, TVE1_REG_SIZE);
+
+	return 0;
+}
+
+inline static void cnc_df_remove_dev(dev_t df_dev)
+{
+	device_destroy(cnc_df_class,df_dev);
+}
+
+static void __exit cnc_df_exit(void)
+{
+	__df_mem_destroy();
+
+	if (NULL != cnc_df_proc_entry)
+		remove_proc_entry("df19_io", NULL);
+
+	cnc_df_remove_dev(MKDEV(DF_MAJOR, DF_MINOR_GFX0));
+	cnc_df_remove_dev(MKDEV(DF_MAJOR, DF_MINOR_GFX1));
+	cnc_df_remove_dev(MKDEV(DF_MAJOR, DF_MINOR_VID0));
+	cnc_df_remove_dev(MKDEV(DF_MAJOR, DF_MINOR_VID1));
+	cnc_df_remove_dev(MKDEV(DF_MAJOR, DF_MINOR_OUT0));
+	cnc_df_remove_dev(MKDEV(DF_MAJOR, DF_MINOR_OUT1));
+	cnc_df_remove_dev(MKDEV(DF_MAJOR, DF_MINOR_TVE0));
+	cnc_df_remove_dev(MKDEV(DF_MAJOR, DF_MINOR_TVE1));
+	cnc_df_remove_dev(MKDEV(DF_MAJOR, DF_MINOR_VIDAUX));
+
+	class_destroy(cnc_df_class);
+	unregister_chrdev(DF_MAJOR, "cnc_df");
+	printk(KERN_INFO "CNC DF Exit ...... OK. \n");
+
+	return;
+}
+
+postcore_initcall(cnc_df_init);
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/df/df_output_format.h linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/df/df_output_format.h
